function derA = FitIGammaGetDerA (beta, v, D, PriorA, PriorBeta)

if beta < 0
    derA = 1;
else
    k = (D-1)/2;
    N = length(v);

    % evaluate dl/da for a given beta:
    if (nargin > 3)
        a0 = FitIGammaSolveA(beta, v, D, PriorBeta);
    else
        a0 = FitIGammaSolveA(beta, v, D);
    end

    vh = 0.5*v;
    derA = N*(psi(a0 + k) - psi(a0) + log(beta))  - sum(log(beta + vh));
    if nargin > 3
        derA = derA + (PriorA.A1 - 1)*log(a0) - (a0/PriorA.A2) - PriorA.A1*log(PriorA.A2) - gammaln(PriorA.A1);
    end
end