function [a1, a2] = FitIGammaGetParams(stat, nElem, j, idxICurr, PriorA, PriorBeta);

if nElem(j) <= 1
    if j > 1
        warning('using previous dimension to calculate IGamma parameters as only one replicate is present');
        j = j - 1;
    else
        warning('using next dimension to calculate IGamma parameters as only one replicate is present');
        j = j + 1;
    end    
end
statCur = stat(idxICurr, j);
statCur = statCur(~isinf(statCur) & ~isnan(statCur));
Dim = nElem(j);

if isempty(statCur)
    a1 = gamstat(PriorA.A1, PriorA.A2);
    a2 = 1/gamstat(PriorBeta.A1, PriorBeta.A2);
else
    if nargin > 4
        beta = fzero(@(x) FitIGammaGetDerA(x, statCur, Dim, PriorA, PriorBeta),1);
        a1 = FitIGammaSolveA (beta, statCur, Dim, PriorBeta);
    else
        beta = fzero(@(x) FitIGammaGetDerA(x, statCur, Dim),1);
        a1 = FitIGammaSolveA (beta, statCur, Dim);
    end
    a2 = 1/beta;
end

