function [a2] = FitIGammaGetScaleGivenDF(stat, nElem, j, idxICurr, df, PriorBeta);

if nElem(j) <= 1
    if j > 1
        warning('using previous dimension to calculate IGamma parameters as only one replicate is present');
        j = j - 1;
    else
        warning('using next dimension to calculate IGamma parameters as only one replicate is present');
        j = j + 1;
    end    
end
statCur = stat(idxICurr, j);
statCur = statCur(~isinf(statCur) & ~isnan(statCur));
Dim = nElem(j);

a1 = df;
if isempty(statCur)
    a2 = 1/gamstat(PriorBeta.A1, PriorBeta.A2);
else
    if nargin > 5
        % ignore priors for now
        beta = fzero(@(x) FitIGammaGetDerB(x, statCur, Dim, df),1);
    else
        beta = fzero(@(x) FitIGammaGetDerB(x, statCur, Dim, df),1);
    end
    a2 = 1/beta;
end

