function [a1, a2] = FitIGammaMMomentsGetParams(stat, nElem, j, idxICurr);

if nElem(j) <= 1
    if j > 1
        warning('using previous dimension to calculate IGamma parameters as only one replicate is present');
        j = j - 1;
    else
        warning('using next dimension to calculate IGamma parameters as only one replicate is present');
        j = j + 1;
    end    
end
statCur = stat(idxICurr, j);
statCur = statCur(~isinf(statCur) & ~isnan(statCur));
Dim = nElem(j);

k = (Dim-1)/2;
sbar = mean(statCur);
svar = var(statCur);

a1 = ((k-1)*sbar + 2*k*svar)/(svar*k - sbar);
a2 = 2*k/((a1-1)*sbar);

