function a = FitIGammaSolveA (beta, v, D, PriorBeta)

minA = 1e-05;
defaultA = 1;

k = (D-1)/2;
N = length(v);

if N >  0
    % solve dl/db = 0 wrt a for a given beta:
    vh = 0.5*v;

    num = sum(k./(beta + vh));
    denom = (N/beta - sum(1./(beta + vh)));
    if nargin  > 3
        C = (PriorBeta.A1 - 1)*log(beta) -  (beta / PriorBeta.A2) - PriorBeta.A1*log(PriorBeta.A2) - lgamma_c(PriorBeta.A1);
        num = num - C;
    end

    a = num / denom;

    if a < 0
        a = minA;
    end
else
    a = defaultA;
end