/*
 * This file was automatically generated for MATLAB by wrap_matlab on
 * Mon May  4 22:56:14 2009
 * from defs.h NIGPeriodic.h NormalIGamma.h.
 */

#include "defs.h"
#include "NIGPeriodic.h"
#include "NormalIGamma.h"

#define MEM_ALLOC(type, n, size) ((type)mxCalloc(n, size))
#ifdef __cplusplus
extern "C" {
#endif
#include "matrix.h"
#include "mex.h"
#ifdef __cplusplus
}
#endif

//
// Return the maximum of the arguments:
//
template <class FLOAT>
inline FLOAT
max(FLOAT arg1, FLOAT arg2)
{
  return arg1 >= arg2 ? arg1 : arg2;
}

/*
 * Return the number of dimensions of an array.
 * This is not well-defined in matlab; we just return the highest dimension
 * which is not 1.
 */
static int
_n_dims(const mxArray *mat)
{
  int n_dim = mxGetNumberOfDimensions(mat); /* Get what matlab thinks. */
  if (n_dim == 2 && mxGetN(mat) == 1) /* 2D array with # of columns = 1? */
  {
    n_dim = 1;			/* It's really a 1D array. */
    if (mxGetM(mat) == 1)	/* Also only one row? */
      n_dim = 0;		/* It's really a scalar. */
  }

  return n_dim;
}

/*
 * Function to get the total number of elements in an array.
 * Arguments:
 * 1) The matlab object.
 *
 * If the object is a scalar, the array length is 1.
 */
static int
_arraylen(const mxArray *mat) {
  int len = 1;
  const int *dims = mxGetDimensions(mat); // Get the number of dimensions.
  int idx;
  for (idx = 0; idx < mxGetNumberOfDimensions(mat); ++idx)
    len *= dims[idx];		// Multiply all the dimensions.

  return len;
}

//
// Get the n'th dimension of a Matlab object.
// Arguments:
// 1) The matlab matrix.
// 2) Which dimension.  0 for the most quickly varying one, etc.
//
static inline int
_dim(const mxArray *mat, int idxno) {
  if (idxno >= mxGetNumberOfDimensions(mat))	// Illegal # of dims?
    return 1;
  else
    return mxGetDimensions(mat)[idxno];	// Return the dimension.
}

//
// Load up an array (which may consist only of a single element) with
// the values from a matlab object.  Arguments:
// 1) The matlab object.
// 2) Where to put the values.  The array should be allocated sufficiently
//    large so that all of the values in the matlab object can be converted.
//
// These functions return 0 on error, or 1 if the operation succeded.
//
template <class FLOAT>
static int
_get_numeric(const mxArray *mat, FLOAT *arr) // float or double.
{
  int idx;
  int n_elements = _arraylen(mat); // Get the length.

  if (mxIsDouble(mat))		// Ordinary double precision matrix?
  {
    double *pr = mxGetPr(mat);	// Point to vector of double precision values.

    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt32(mat) || mxIsUint32(mat)) // 32 bit integer?
  {
    INT32_T *pr = (INT32_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt16(mat) || mxIsUint16(mat)) // 16 bit integer?
  {
    INT16_T *pr = (INT16_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else if (mxIsInt8(mat) || mxIsUint8(mat)) // 8 bit integer?
  {
    INT8_T *pr = (INT8_T *)mxGetData(mat); // Point to the data.
    for (idx = 0; idx < n_elements; ++idx) // Loop through all elements.
      *arr++ = (FLOAT)*pr++;	// Convert and copy this element.
  }
  else				// Don't know what this is.
    return 0;			// Type conversion error.

  return 1;			// No error.
}

//
/*
 * Check to see if the vectorizing dimensions on an input argument are
 * ok.  Arguments:
 * 1) The input argument.
 * 2) The number of vectorizing dimensions we have so far.  This is updated
 *    if we add more vectorizing dimensions.
 * 3) An array containing the existing vectorizing dimensions.
 * 4) The number of explicitly declared dimensions, i.e., 0 if this was
 *    declared as a scalar, 1 if a vector.  We vectorize only the dimensions
 *    higher than the explicitly declared ones.
 * 5) A value which is set to 0 if this argument is not vectorized.  This
 *    value is left unaltered if the argument is vectorized.
 *
 * Returns 0 if there was a problem, 1 if the dimensions were ok.
 */
int
_check_input_vectorize(const mxArray *arg,
                       int *n_vec_dim,
		       int _d[4],
		       int explicit_dims,
		       int *vec_stride)
{
  int v_idx;

  int n_dims = _n_dims(arg);

  if (n_dims > explicit_dims)	/* Any additional dimensions? */
  {
    if (*n_vec_dim == 0)	/* No vectorizing dimensions seen yet? */
    {				/* This defines the vectorizing dimensions. */
      *n_vec_dim = n_dims - explicit_dims; /* Remember the # of dims. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        _d[v_idx] = _dim(arg, v_idx+explicit_dims); /* Remember this dim. */
    } 
    else			/* Already had some vectorizing dimensions. */
    {				/* These must match exactly. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        if (_d[v_idx] != _dim(arg, v_idx+explicit_dims)) /* Wrong size? */
          return 0;		/* Error! */
    }
  }  
/*  else if (n_dims < explicit_dims) */ /* Too few dimensions? */
/*    return 0; */ /* We don't do this check because there's no way to
		    * distinguish between a vector and a 3x1 matrix. */
  else
    *vec_stride = 0;		/* Vectorization not required. */

  return 1;
}

/*
 * Same thing except for modify variables.  Arguments:
 * 1) The input argument.
 * 2) The number of vectorizing dimensions we have so far.
 * 3) An array containing the existing vectorizing dimensions.
 * 4) The number of explicitly declared dimensions, i.e., 0 if this was
 *    declared as a scalar, 1 if a vector.  We vectorize only the dimensions
 *    higher than the explicitly declared ones.
 * 5) A flag indicating whether this is the first modify variable.  This
 *    flag is passed by reference and updated by this subroutine.
 *
 * The vectorizing dimensions of modify arguments must exactly match those
 * specified for input variables.  The difference between this subroutine
 * and _check_input_vectorize is that only the first modify variable may
 * specify additional vectorizing dimensions.
 *
 * Returns 0 if there was a problem, 1 if the dimensions were ok.
 */
int
_check_modify_vectorize(const mxArray *arg,
		        int *n_vec_dim,
		        int _d[4],
		        int explicit_dims,
			int *first_modify_flag)
{
  int v_idx;

  int n_dims = _n_dims(arg);

  if (n_dims > explicit_dims)	/* Any additional dimensions? */
  {
    if (*n_vec_dim == 0 && *first_modify_flag)	/* No vectorizing dimensions seen yet? */
    {				/* This defines the vectorizing dimensions. */
      *n_vec_dim = n_dims - explicit_dims; /* Remember the # of dims. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        _d[v_idx] = _dim(arg, v_idx+explicit_dims); /* Remember this dim. */
    } 
    else			/* Already had some vectorizing dimensions. */
    {				/* These must match exactly. */
      for (v_idx = 0; v_idx < 4-explicit_dims; ++v_idx)
        if (_d[v_idx] != _dim(arg, v_idx+explicit_dims)) /* Wrong size? */
          return 0;		/* Error! */
    }
  }  
/*  else if (n_dims < explicit_dims) */ /* Too few dimensions? */
/*    return 0; */ /* We don't do this check because there's no way to
		    * distinguish between a vector and a 3x1 matrix. */

  *first_modify_flag = 0;	/* Next modify variable will not be first. */
  return 1;
}


/*
 * Convert between classes, handling inheritance relationships.
 * Arguments:
 * 1) The pointer.
 * 2) The type code for its class.
 * 3) The type code for the class you want.
 *
 * Returns 0 if the conversion is illegal, or else returns the
 * desired pointer.
 * We assume that you have already verified that the type code does
 * not match, so the only valid possibility is an inheritance
 * relationship.
 */
static void *
__cvt_type(void *, unsigned, unsigned)
{
  return 0;
}

//
// Local functions dealing with pointers:
//
// Pointers are stored as complex numbers.  The real part is the pointer
// value, and the complex part is the type code.  Since the real part will be
// a double precision number, the pointer is guaranteed to fit, even on
// 64-bit machines.
//
// Fill an array with pointers.  Arguments:
// 1) A pointer to the array to fill.  The array is already the correct size.
// 2) The matlab object.
// 3) The pointer type code.
//
// Returns false if some of the pointers have the wrong type.
//
static int
_get_pointer(void **arr, const mxArray *mat, unsigned typecode)
{
  int idx;
  int n_elements;
  double *pr, *pi;

  if (!mxIsComplex(mat))	// Make sure it's the right type.
    return 0;

  n_elements = _arraylen(mat);	// Get the number of elements to convert.
  pr = mxGetPr(mat);		// Get a pointer to the real part.
  pi = mxGetPi(mat);		// Get a pointer to the complex part.
  for (idx = 0; idx < n_elements; ++idx)
  {				// Look at each element:
    unsigned this_typecode = (unsigned)*pi++; // Get the type code.
    if (this_typecode == typecode) // Correct type?
      *arr++ = *(void **)pr;	// Do the conversion.
    else
    {
      *arr = __cvt_type(*(void **)pr, this_typecode, typecode);
				// Check inheritance.
      if (*arr++ == 0) return 0; // Wrong type.
    }

    ++pr;			// Point to the next element.
  }

  return 1;			// No error.
}

//
// Load a matrix with a pointer or an array of pointers.  This assumes
// that the matrix has already been allocated to the correct size
// (that's how we know how many elements to convert).
//
static void
_put_pointer(mxArray *mat, void **ptr_array, double type_code)
{
  int idx;
  int n_elements;
  double *pr, *pi;
 
  n_elements = _arraylen(mat);	// Get the number of elements to convert.
  pr = mxGetPr(mat);		// Get a pointer to the real part.
  pi = mxGetPi(mat);		// Get a pointer to the complex part.

  for (idx = 0; idx < n_elements; ++idx)
  {
    *pi++ = type_code;		// Remember the type code.
    *pr = 0;			// Wipe out any extra bits the address
				// doesn't cover, in case we're on a
				// 32 bit machine.
    *(void **)pr = *ptr_array++; // Remember the address.
    ++pr;			// Advance the pointer.
  }
}
void _wrap_GetLogPYNormalIGamma(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 7 ||
      nrhs != 6+1)
    mexErrMsgTxt("Wrong number of arguments to function GetLogPYNormalIGamma");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_LogPY;
  double *_arg_LogPYGivenZ;
  double *_arg_PostMu;
  double *_arg_PostSc;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_PostZ;
  double *_arg_Data;
  double *_arg_PriorMu;
  double *_arg_PriorSc;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  double *_arg_PriorPZ;
  int _arg_N;
  int _arg_D;
  int _arg_GZ;
  _arg_N = (_dim(prhs[1], 0));
  _arg_GZ = (_dim(prhs[6], 0));
  _arg_D = (_dim(prhs[5], 1));
  int _vecstride_Data = _arg_N*_arg_D;
  int _vecstride_PriorMu = _arg_GZ*_arg_D;
  int _vecstride_PriorSc = _arg_GZ*_arg_D;
  int _vecstride_PriorA1 = _arg_GZ*_arg_D;
  int _vecstride_PriorA2 = _arg_GZ*_arg_D;
  int _vecstride_PriorPZ = _arg_GZ;
  if (  (int)(_dim(prhs[1], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_Data))
    mexErrMsgTxt("Error in dimension of argument Data");
  if (mxIsDouble(prhs[1]))
    _arg_Data = mxGetPr(prhs[1]);
  else
  {
    _arg_Data = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Data))
      mexErrMsgTxt("Expecting numeric matrix for argument Data");
  }

  if (  (int)(_dim(prhs[2], 0)) != (int)(_arg_GZ) ||
        (int)(_dim(prhs[2], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[2], &_vec_n, _d, 2, &_vecstride_PriorMu))
    mexErrMsgTxt("Error in dimension of argument PriorMu");
  if (mxIsDouble(prhs[2]))
    _arg_PriorMu = mxGetPr(prhs[2]);
  else
  {
    _arg_PriorMu = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_PriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorMu");
  }

  if (  (int)(_dim(prhs[3], 0)) != (int)(_arg_GZ) ||
        (int)(_dim(prhs[3], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[3], &_vec_n, _d, 2, &_vecstride_PriorSc))
    mexErrMsgTxt("Error in dimension of argument PriorSc");
  if (mxIsDouble(prhs[3]))
    _arg_PriorSc = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorSc = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorSc))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorSc");
  }

  if (  (int)(_dim(prhs[4], 0)) != (int)(_arg_GZ) ||
        (int)(_dim(prhs[4], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[4], &_vec_n, _d, 2, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[4]))
    _arg_PriorA1 = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (  (int)(_dim(prhs[5], 0)) != (int)(_arg_GZ) ||
      !_check_input_vectorize(prhs[5], &_vec_n, _d, 2, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[5]))
    _arg_PriorA2 = mxGetPr(prhs[5]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  if (!_check_input_vectorize(prhs[6], &_vec_n, _d, 1, &_vecstride_PriorPZ))
    mexErrMsgTxt("Error in dimension of argument PriorPZ");
  if (mxIsDouble(prhs[6]))
    _arg_PriorPZ = mxGetPr(prhs[6]);
  else
  {
    _arg_PriorPZ = MEM_ALLOC(double *, _arraylen(prhs[6]), sizeof (double));
    if (!_get_numeric(prhs[6], _arg_PriorPZ))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorPZ");
  }

  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPY = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_GZ, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPYGivenZ = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _arg_GZ, _arg_D, _d[0] , _d[1]  };
    plhs[2] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostMu = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { _arg_GZ, _arg_D, _d[0] , _d[1]  };
    plhs[3] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostSc = mxGetPr(plhs[3]);
  }
  {
    int _ds[] = { _arg_GZ, _arg_D, _d[0] , _d[1]  };
    plhs[4] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[4]);
  }
  {
    int _ds[] = { _arg_GZ, _arg_D, _d[0] , _d[1]  };
    plhs[5] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[5]);
  }
  {
    int _ds[] = { _arg_GZ, _d[0] , _d[1] , _d[2]  };
    plhs[6] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostZ = mxGetPr(plhs[6]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    GetLogPYNormalIGamma(&_arg_LogPY[1*_vidx], &_arg_LogPYGivenZ[_arg_GZ*_vidx], &_arg_PostMu[_arg_GZ*_arg_D*_vidx], &_arg_PostSc[_arg_GZ*_arg_D*_vidx], &_arg_PostA1[_arg_GZ*_arg_D*_vidx], &_arg_PostA2[_arg_GZ*_arg_D*_vidx], &_arg_PostZ[_arg_GZ*_vidx], &_arg_Data[_vecstride_Data*_vidx], &_arg_PriorMu[_vecstride_PriorMu*_vidx], &_arg_PriorSc[_vecstride_PriorSc*_vidx], &_arg_PriorA1[_vecstride_PriorA1*_vidx], &_arg_PriorA2[_vecstride_PriorA2*_vidx], &_arg_PriorPZ[_vecstride_PriorPZ*_vidx], _arg_N, _arg_D, _arg_GZ);
  }
}

void _wrap_GetLogPYNormalIGamma1Dim(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 5 ||
      nrhs != 5+1)
    mexErrMsgTxt("Wrong number of arguments to function GetLogPYNormalIGamma1Dim");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_LogPY;
  double *_arg_PostMu;
  double *_arg_PostSc;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Data;
  double *_arg_PriorMu;
  double *_arg_PriorSc;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  _arg_N = (_dim(prhs[1], 0));
  int _vecstride_Data = _arg_N;
  int _vecstride_PriorMu = 1;
  int _vecstride_PriorSc = 1;
  int _vecstride_PriorA1 = 1;
  int _vecstride_PriorA2 = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 1, &_vecstride_Data))
    mexErrMsgTxt("Error in dimension of argument Data");
  if (mxIsDouble(prhs[1]))
    _arg_Data = mxGetPr(prhs[1]);
  else
  {
    _arg_Data = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Data))
      mexErrMsgTxt("Expecting numeric matrix for argument Data");
  }

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_PriorMu))
    mexErrMsgTxt("Error in dimension of argument PriorMu");
  if (mxIsDouble(prhs[2]))
    _arg_PriorMu = mxGetPr(prhs[2]);
  else
  {
    _arg_PriorMu = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_PriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorMu");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_PriorSc))
    mexErrMsgTxt("Error in dimension of argument PriorSc");
  if (mxIsDouble(prhs[3]))
    _arg_PriorSc = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorSc = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorSc))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorSc");
  }

  if (!_check_input_vectorize(prhs[4], &_vec_n, _d, 0, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[4]))
    _arg_PriorA1 = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[5], &_vec_n, _d, 0, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[5]))
    _arg_PriorA2 = mxGetPr(prhs[5]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPY = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostMu = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[2] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostSc = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[3] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[3]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[4] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[4]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    GetLogPYNormalIGamma1Dim(&_arg_LogPY[1*_vidx], &_arg_PostMu[1*_vidx], &_arg_PostSc[1*_vidx], &_arg_PostA1[1*_vidx], &_arg_PostA2[1*_vidx], &_arg_Data[_vecstride_Data*_vidx], _arg_PriorMu[_vecstride_PriorMu*_vidx], _arg_PriorSc[_vecstride_PriorSc*_vidx], _arg_PriorA1[_vecstride_PriorA1*_vidx], _arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N);
  }
}

void _wrap_GetLogPYNormalIGammaGZ1(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 5 ||
      nrhs != 5+1)
    mexErrMsgTxt("Wrong number of arguments to function GetLogPYNormalIGammaGZ1");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_LogPY;
  double *_arg_PostMu;
  double *_arg_PostSc;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Data;
  double *_arg_PriorMu;
  double *_arg_PriorSc;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  int _arg_D;
  _arg_N = (_dim(prhs[1], 0));
  _arg_D = (_dim(prhs[5], 0));
  int _vecstride_Data = _arg_N*_arg_D;
  int _vecstride_PriorMu = _arg_D;
  int _vecstride_PriorSc = _arg_D;
  int _vecstride_PriorA1 = _arg_D;
  int _vecstride_PriorA2 = _arg_D;
  if (  (int)(_dim(prhs[1], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_Data))
    mexErrMsgTxt("Error in dimension of argument Data");
  if (mxIsDouble(prhs[1]))
    _arg_Data = mxGetPr(prhs[1]);
  else
  {
    _arg_Data = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Data))
      mexErrMsgTxt("Expecting numeric matrix for argument Data");
  }

  if (  (int)(_dim(prhs[2], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[2], &_vec_n, _d, 1, &_vecstride_PriorMu))
    mexErrMsgTxt("Error in dimension of argument PriorMu");
  if (mxIsDouble(prhs[2]))
    _arg_PriorMu = mxGetPr(prhs[2]);
  else
  {
    _arg_PriorMu = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_PriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorMu");
  }

  if (  (int)(_dim(prhs[3], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[3], &_vec_n, _d, 1, &_vecstride_PriorSc))
    mexErrMsgTxt("Error in dimension of argument PriorSc");
  if (mxIsDouble(prhs[3]))
    _arg_PriorSc = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorSc = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorSc))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorSc");
  }

  if (  (int)(_dim(prhs[4], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[4], &_vec_n, _d, 1, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[4]))
    _arg_PriorA1 = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[5], &_vec_n, _d, 1, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[5]))
    _arg_PriorA2 = mxGetPr(prhs[5]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPY = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostMu = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[2] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostSc = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[3] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[3]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[4] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[4]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    GetLogPYNormalIGammaGZ1(&_arg_LogPY[1*_vidx], &_arg_PostMu[_arg_D*_vidx], &_arg_PostSc[_arg_D*_vidx], &_arg_PostA1[_arg_D*_vidx], &_arg_PostA2[_arg_D*_vidx], &_arg_Data[_vecstride_Data*_vidx], &_arg_PriorMu[_vecstride_PriorMu*_vidx], &_arg_PriorSc[_vecstride_PriorSc*_vidx], &_arg_PriorA1[_vecstride_PriorA1*_vidx], &_arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N, _arg_D);
  }
}

void _wrap_GetSPLogP(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 6 ||
      nrhs != 17+1)
    mexErrMsgTxt("Wrong number of arguments to function GetSPLogP");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_LogPY;
  double *_arg_LogPKGivenY;
  double *_arg_LogPYGivenK;
  double *_arg_ThetaPR;
  double *_arg_ThetaDE;
  double *_arg_ThetaBG;
  double *_arg_DataMatr;
  double *_arg_NRepl;
  double *_arg_CycleDep;
  double *_arg_NCycleDep;
  double *_arg_PComp;
  double *_arg_PRPriorMu;
  double *_arg_PRPriorK0;
  double *_arg_PRPriorA1;
  double *_arg_PRPriorA2;
  double *_arg_DEPriorMu;
  double *_arg_DEPriorK0;
  double *_arg_DEPriorA1;
  double *_arg_DEPriorA2;
  double *_arg_BGPriorMu;
  double *_arg_BGPriorK0;
  double *_arg_BGPriorA1;
  double *_arg_BGPriorA2;
  int _arg_N;
  int _arg_DNMaxRepl;
  int _arg_D;
  int _arg_T;
  int _arg_NMaxCycleDep;
  _arg_T = (_dim(prhs[9], 0));
  _arg_N = (_dim(prhs[2], 0));
  _arg_NMaxCycleDep = (_dim(prhs[3], 1));
  _arg_D = (_dim(prhs[13], 0));
  _arg_DNMaxRepl = (_dim(prhs[1], 1));
  int _vecstride_DataMatr = _arg_N*_arg_DNMaxRepl;
  int _vecstride_NRepl = _arg_N*_arg_D;
  int _vecstride_CycleDep = _arg_T*_arg_NMaxCycleDep;
  int _vecstride_NCycleDep = _arg_T;
  int _vecstride_PComp = 3;
  int _vecstride_PRPriorMu = _arg_T;
  int _vecstride_PRPriorK0 = _arg_T;
  int _vecstride_PRPriorA1 = _arg_T;
  int _vecstride_PRPriorA2 = _arg_T;
  int _vecstride_DEPriorMu = _arg_D;
  int _vecstride_DEPriorK0 = _arg_D;
  int _vecstride_DEPriorA1 = _arg_D;
  int _vecstride_DEPriorA2 = _arg_D;
  int _vecstride_BGPriorMu = 1;
  int _vecstride_BGPriorK0 = 1;
  int _vecstride_BGPriorA1 = 1;
  int _vecstride_BGPriorA2 = 1;
  if (  (int)(_dim(prhs[1], 0)) != (int)(_arg_N) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_DataMatr))
    mexErrMsgTxt("Error in dimension of argument DataMatr");
  if (mxIsDouble(prhs[1]))
    _arg_DataMatr = mxGetPr(prhs[1]);
  else
  {
    _arg_DataMatr = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_DataMatr))
      mexErrMsgTxt("Expecting numeric matrix for argument DataMatr");
  }

  if (  (int)(_dim(prhs[2], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[2], &_vec_n, _d, 2, &_vecstride_NRepl))
    mexErrMsgTxt("Error in dimension of argument NRepl");
  if (mxIsDouble(prhs[2]))
    _arg_NRepl = mxGetPr(prhs[2]);
  else
  {
    _arg_NRepl = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_NRepl))
      mexErrMsgTxt("Expecting numeric matrix for argument NRepl");
  }

  if (  (int)(_dim(prhs[3], 0)) != (int)(_arg_T) ||
      !_check_input_vectorize(prhs[3], &_vec_n, _d, 2, &_vecstride_CycleDep))
    mexErrMsgTxt("Error in dimension of argument CycleDep");
  if (mxIsDouble(prhs[3]))
    _arg_CycleDep = mxGetPr(prhs[3]);
  else
  {
    _arg_CycleDep = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_CycleDep))
      mexErrMsgTxt("Expecting numeric matrix for argument CycleDep");
  }

  if (  (int)(_dim(prhs[4], 0)) != (int)(_arg_T) ||
      !_check_input_vectorize(prhs[4], &_vec_n, _d, 1, &_vecstride_NCycleDep))
    mexErrMsgTxt("Error in dimension of argument NCycleDep");
  if (mxIsDouble(prhs[4]))
    _arg_NCycleDep = mxGetPr(prhs[4]);
  else
  {
    _arg_NCycleDep = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_NCycleDep))
      mexErrMsgTxt("Expecting numeric matrix for argument NCycleDep");
  }

  if (  (int)(_dim(prhs[5], 0)) != (int)(3) ||
      !_check_input_vectorize(prhs[5], &_vec_n, _d, 1, &_vecstride_PComp))
    mexErrMsgTxt("Error in dimension of argument PComp");
  if (mxIsDouble(prhs[5]))
    _arg_PComp = mxGetPr(prhs[5]);
  else
  {
    _arg_PComp = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PComp))
      mexErrMsgTxt("Expecting numeric matrix for argument PComp");
  }

  if (  (int)(_dim(prhs[6], 0)) != (int)(_arg_T) ||
      !_check_input_vectorize(prhs[6], &_vec_n, _d, 1, &_vecstride_PRPriorMu))
    mexErrMsgTxt("Error in dimension of argument PRPriorMu");
  if (mxIsDouble(prhs[6]))
    _arg_PRPriorMu = mxGetPr(prhs[6]);
  else
  {
    _arg_PRPriorMu = MEM_ALLOC(double *, _arraylen(prhs[6]), sizeof (double));
    if (!_get_numeric(prhs[6], _arg_PRPriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PRPriorMu");
  }

  if (  (int)(_dim(prhs[7], 0)) != (int)(_arg_T) ||
      !_check_input_vectorize(prhs[7], &_vec_n, _d, 1, &_vecstride_PRPriorK0))
    mexErrMsgTxt("Error in dimension of argument PRPriorK0");
  if (mxIsDouble(prhs[7]))
    _arg_PRPriorK0 = mxGetPr(prhs[7]);
  else
  {
    _arg_PRPriorK0 = MEM_ALLOC(double *, _arraylen(prhs[7]), sizeof (double));
    if (!_get_numeric(prhs[7], _arg_PRPriorK0))
      mexErrMsgTxt("Expecting numeric matrix for argument PRPriorK0");
  }

  if (  (int)(_dim(prhs[8], 0)) != (int)(_arg_T) ||
      !_check_input_vectorize(prhs[8], &_vec_n, _d, 1, &_vecstride_PRPriorA1))
    mexErrMsgTxt("Error in dimension of argument PRPriorA1");
  if (mxIsDouble(prhs[8]))
    _arg_PRPriorA1 = mxGetPr(prhs[8]);
  else
  {
    _arg_PRPriorA1 = MEM_ALLOC(double *, _arraylen(prhs[8]), sizeof (double));
    if (!_get_numeric(prhs[8], _arg_PRPriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PRPriorA1");
  }

  if (!_check_input_vectorize(prhs[9], &_vec_n, _d, 1, &_vecstride_PRPriorA2))
    mexErrMsgTxt("Error in dimension of argument PRPriorA2");
  if (mxIsDouble(prhs[9]))
    _arg_PRPriorA2 = mxGetPr(prhs[9]);
  else
  {
    _arg_PRPriorA2 = MEM_ALLOC(double *, _arraylen(prhs[9]), sizeof (double));
    if (!_get_numeric(prhs[9], _arg_PRPriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PRPriorA2");
  }

  if (  (int)(_dim(prhs[10], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[10], &_vec_n, _d, 1, &_vecstride_DEPriorMu))
    mexErrMsgTxt("Error in dimension of argument DEPriorMu");
  if (mxIsDouble(prhs[10]))
    _arg_DEPriorMu = mxGetPr(prhs[10]);
  else
  {
    _arg_DEPriorMu = MEM_ALLOC(double *, _arraylen(prhs[10]), sizeof (double));
    if (!_get_numeric(prhs[10], _arg_DEPriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument DEPriorMu");
  }

  if (  (int)(_dim(prhs[11], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[11], &_vec_n, _d, 1, &_vecstride_DEPriorK0))
    mexErrMsgTxt("Error in dimension of argument DEPriorK0");
  if (mxIsDouble(prhs[11]))
    _arg_DEPriorK0 = mxGetPr(prhs[11]);
  else
  {
    _arg_DEPriorK0 = MEM_ALLOC(double *, _arraylen(prhs[11]), sizeof (double));
    if (!_get_numeric(prhs[11], _arg_DEPriorK0))
      mexErrMsgTxt("Expecting numeric matrix for argument DEPriorK0");
  }

  if (  (int)(_dim(prhs[12], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[12], &_vec_n, _d, 1, &_vecstride_DEPriorA1))
    mexErrMsgTxt("Error in dimension of argument DEPriorA1");
  if (mxIsDouble(prhs[12]))
    _arg_DEPriorA1 = mxGetPr(prhs[12]);
  else
  {
    _arg_DEPriorA1 = MEM_ALLOC(double *, _arraylen(prhs[12]), sizeof (double));
    if (!_get_numeric(prhs[12], _arg_DEPriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument DEPriorA1");
  }

  if (!_check_input_vectorize(prhs[13], &_vec_n, _d, 1, &_vecstride_DEPriorA2))
    mexErrMsgTxt("Error in dimension of argument DEPriorA2");
  if (mxIsDouble(prhs[13]))
    _arg_DEPriorA2 = mxGetPr(prhs[13]);
  else
  {
    _arg_DEPriorA2 = MEM_ALLOC(double *, _arraylen(prhs[13]), sizeof (double));
    if (!_get_numeric(prhs[13], _arg_DEPriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument DEPriorA2");
  }

  if (  (int)(_dim(prhs[14], 0)) != (int)(1) ||
      !_check_input_vectorize(prhs[14], &_vec_n, _d, 1, &_vecstride_BGPriorMu))
    mexErrMsgTxt("Error in dimension of argument BGPriorMu");
  if (mxIsDouble(prhs[14]))
    _arg_BGPriorMu = mxGetPr(prhs[14]);
  else
  {
    _arg_BGPriorMu = MEM_ALLOC(double *, _arraylen(prhs[14]), sizeof (double));
    if (!_get_numeric(prhs[14], _arg_BGPriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument BGPriorMu");
  }

  if (  (int)(_dim(prhs[15], 0)) != (int)(1) ||
      !_check_input_vectorize(prhs[15], &_vec_n, _d, 1, &_vecstride_BGPriorK0))
    mexErrMsgTxt("Error in dimension of argument BGPriorK0");
  if (mxIsDouble(prhs[15]))
    _arg_BGPriorK0 = mxGetPr(prhs[15]);
  else
  {
    _arg_BGPriorK0 = MEM_ALLOC(double *, _arraylen(prhs[15]), sizeof (double));
    if (!_get_numeric(prhs[15], _arg_BGPriorK0))
      mexErrMsgTxt("Expecting numeric matrix for argument BGPriorK0");
  }

  if (  (int)(_dim(prhs[16], 0)) != (int)(1) ||
      !_check_input_vectorize(prhs[16], &_vec_n, _d, 1, &_vecstride_BGPriorA1))
    mexErrMsgTxt("Error in dimension of argument BGPriorA1");
  if (mxIsDouble(prhs[16]))
    _arg_BGPriorA1 = mxGetPr(prhs[16]);
  else
  {
    _arg_BGPriorA1 = MEM_ALLOC(double *, _arraylen(prhs[16]), sizeof (double));
    if (!_get_numeric(prhs[16], _arg_BGPriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument BGPriorA1");
  }

  if (  (int)(_dim(prhs[17], 0)) != (int)(1) ||
      !_check_input_vectorize(prhs[17], &_vec_n, _d, 1, &_vecstride_BGPriorA2))
    mexErrMsgTxt("Error in dimension of argument BGPriorA2");
  if (mxIsDouble(prhs[17]))
    _arg_BGPriorA2 = mxGetPr(prhs[17]);
  else
  {
    _arg_BGPriorA2 = MEM_ALLOC(double *, _arraylen(prhs[17]), sizeof (double));
    if (!_get_numeric(prhs[17], _arg_BGPriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument BGPriorA2");
  }

  {
    int _ds[] = { _arg_N, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPY = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_N, 3, _d[0] , _d[1]  };
    plhs[1] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPKGivenY = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _arg_N, 3, _d[0] , _d[1]  };
    plhs[2] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPYGivenK = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { _arg_N, _arg_T, 2, _d[0]  };
    plhs[3] = mxCreateNumericArray(max((3 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_ThetaPR = mxGetPr(plhs[3]);
  }
  {
    int _ds[] = { _arg_N, _arg_D, 2, _d[0]  };
    plhs[4] = mxCreateNumericArray(max((3 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_ThetaDE = mxGetPr(plhs[4]);
  }
  {
    int _ds[] = { _arg_N, 2, _d[0] , _d[1]  };
    plhs[5] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_ThetaBG = mxGetPr(plhs[5]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    GetSPLogP(&_arg_LogPY[_arg_N*_vidx], &_arg_LogPKGivenY[_arg_N*3*_vidx], &_arg_LogPYGivenK[_arg_N*3*_vidx], &_arg_ThetaPR[_arg_N*_arg_T*2*_vidx], &_arg_ThetaDE[_arg_N*_arg_D*2*_vidx], &_arg_ThetaBG[_arg_N*2*_vidx], &_arg_DataMatr[_vecstride_DataMatr*_vidx], &_arg_NRepl[_vecstride_NRepl*_vidx], &_arg_CycleDep[_vecstride_CycleDep*_vidx], &_arg_NCycleDep[_vecstride_NCycleDep*_vidx], &_arg_PComp[_vecstride_PComp*_vidx], &_arg_PRPriorMu[_vecstride_PRPriorMu*_vidx], &_arg_PRPriorK0[_vecstride_PRPriorK0*_vidx], &_arg_PRPriorA1[_vecstride_PRPriorA1*_vidx], &_arg_PRPriorA2[_vecstride_PRPriorA2*_vidx], &_arg_DEPriorMu[_vecstride_DEPriorMu*_vidx], &_arg_DEPriorK0[_vecstride_DEPriorK0*_vidx], &_arg_DEPriorA1[_vecstride_DEPriorA1*_vidx], &_arg_DEPriorA2[_vecstride_DEPriorA2*_vidx], &_arg_BGPriorMu[_vecstride_BGPriorMu*_vidx], &_arg_BGPriorK0[_vecstride_BGPriorK0*_vidx], &_arg_BGPriorA1[_vecstride_BGPriorA1*_vidx], &_arg_BGPriorA2[_vecstride_BGPriorA2*_vidx], _arg_N, _arg_DNMaxRepl, _arg_D, _arg_T, _arg_NMaxCycleDep);
  }
}

void _wrap_GetSPMultiCompLogP(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 5 ||
      nrhs != 10+1)
    mexErrMsgTxt("Wrong number of arguments to function GetSPMultiCompLogP");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_LogPY;
  double *_arg_LogPKGivenY;
  double *_arg_LogPYGivenK;
  double *_arg_Mu;
  double *_arg_RV;
  double *_arg_DataMatr;
  double *_arg_NRepl;
  double *_arg_CycleDep;
  double *_arg_NCycleDep;
  double *_arg_PComp;
  double *_arg_CompType;
  double *_arg_PriorMu;
  double *_arg_PriorK0;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  int _arg_DNMaxRepl;
  int _arg_D;
  int _arg_T;
  int _arg_K;
  int _arg_NMaxCycleDep;
  _arg_T = (_dim(prhs[4], 0));
  _arg_N = (_dim(prhs[2], 0));
  _arg_K = (_dim(prhs[10], 0));
  _arg_NMaxCycleDep = (_dim(prhs[3], 1));
  _arg_D = (_dim(prhs[10], 1));
  _arg_DNMaxRepl = (_dim(prhs[1], 1));
  int _vecstride_DataMatr = _arg_N*_arg_DNMaxRepl;
  int _vecstride_NRepl = _arg_N*_arg_D;
  int _vecstride_CycleDep = _arg_T*_arg_NMaxCycleDep;
  int _vecstride_NCycleDep = _arg_T;
  int _vecstride_PComp = _arg_K;
  int _vecstride_CompType = _arg_K;
  int _vecstride_PriorMu = _arg_K*_arg_D;
  int _vecstride_PriorK0 = _arg_K*_arg_D;
  int _vecstride_PriorA1 = _arg_K*_arg_D;
  int _vecstride_PriorA2 = _arg_K*_arg_D;
  if (  (int)(_dim(prhs[1], 0)) != (int)(_arg_N) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_DataMatr))
    mexErrMsgTxt("Error in dimension of argument DataMatr");
  if (mxIsDouble(prhs[1]))
    _arg_DataMatr = mxGetPr(prhs[1]);
  else
  {
    _arg_DataMatr = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_DataMatr))
      mexErrMsgTxt("Expecting numeric matrix for argument DataMatr");
  }

  if (  (int)(_dim(prhs[2], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[2], &_vec_n, _d, 2, &_vecstride_NRepl))
    mexErrMsgTxt("Error in dimension of argument NRepl");
  if (mxIsDouble(prhs[2]))
    _arg_NRepl = mxGetPr(prhs[2]);
  else
  {
    _arg_NRepl = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_NRepl))
      mexErrMsgTxt("Expecting numeric matrix for argument NRepl");
  }

  if (  (int)(_dim(prhs[3], 0)) != (int)(_arg_T) ||
      !_check_input_vectorize(prhs[3], &_vec_n, _d, 2, &_vecstride_CycleDep))
    mexErrMsgTxt("Error in dimension of argument CycleDep");
  if (mxIsDouble(prhs[3]))
    _arg_CycleDep = mxGetPr(prhs[3]);
  else
  {
    _arg_CycleDep = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_CycleDep))
      mexErrMsgTxt("Expecting numeric matrix for argument CycleDep");
  }

  if (!_check_input_vectorize(prhs[4], &_vec_n, _d, 1, &_vecstride_NCycleDep))
    mexErrMsgTxt("Error in dimension of argument NCycleDep");
  if (mxIsDouble(prhs[4]))
    _arg_NCycleDep = mxGetPr(prhs[4]);
  else
  {
    _arg_NCycleDep = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_NCycleDep))
      mexErrMsgTxt("Expecting numeric matrix for argument NCycleDep");
  }

  if (  (int)(_dim(prhs[5], 0)) != (int)(_arg_K) ||
      !_check_input_vectorize(prhs[5], &_vec_n, _d, 1, &_vecstride_PComp))
    mexErrMsgTxt("Error in dimension of argument PComp");
  if (mxIsDouble(prhs[5]))
    _arg_PComp = mxGetPr(prhs[5]);
  else
  {
    _arg_PComp = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PComp))
      mexErrMsgTxt("Expecting numeric matrix for argument PComp");
  }

  if (  (int)(_dim(prhs[6], 0)) != (int)(_arg_K) ||
      !_check_input_vectorize(prhs[6], &_vec_n, _d, 1, &_vecstride_CompType))
    mexErrMsgTxt("Error in dimension of argument CompType");
  if (mxIsDouble(prhs[6]))
    _arg_CompType = mxGetPr(prhs[6]);
  else
  {
    _arg_CompType = MEM_ALLOC(double *, _arraylen(prhs[6]), sizeof (double));
    if (!_get_numeric(prhs[6], _arg_CompType))
      mexErrMsgTxt("Expecting numeric matrix for argument CompType");
  }

  if (  (int)(_dim(prhs[7], 0)) != (int)(_arg_K) ||
        (int)(_dim(prhs[7], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[7], &_vec_n, _d, 2, &_vecstride_PriorMu))
    mexErrMsgTxt("Error in dimension of argument PriorMu");
  if (mxIsDouble(prhs[7]))
    _arg_PriorMu = mxGetPr(prhs[7]);
  else
  {
    _arg_PriorMu = MEM_ALLOC(double *, _arraylen(prhs[7]), sizeof (double));
    if (!_get_numeric(prhs[7], _arg_PriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorMu");
  }

  if (  (int)(_dim(prhs[8], 0)) != (int)(_arg_K) ||
        (int)(_dim(prhs[8], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[8], &_vec_n, _d, 2, &_vecstride_PriorK0))
    mexErrMsgTxt("Error in dimension of argument PriorK0");
  if (mxIsDouble(prhs[8]))
    _arg_PriorK0 = mxGetPr(prhs[8]);
  else
  {
    _arg_PriorK0 = MEM_ALLOC(double *, _arraylen(prhs[8]), sizeof (double));
    if (!_get_numeric(prhs[8], _arg_PriorK0))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorK0");
  }

  if (  (int)(_dim(prhs[9], 0)) != (int)(_arg_K) ||
        (int)(_dim(prhs[9], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[9], &_vec_n, _d, 2, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[9]))
    _arg_PriorA1 = mxGetPr(prhs[9]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[9]), sizeof (double));
    if (!_get_numeric(prhs[9], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[10], &_vec_n, _d, 2, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[10]))
    _arg_PriorA2 = mxGetPr(prhs[10]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[10]), sizeof (double));
    if (!_get_numeric(prhs[10], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { _arg_N, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPY = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_N, _arg_K, _d[0] , _d[1]  };
    plhs[1] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPKGivenY = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _arg_N, _arg_K, _d[0] , _d[1]  };
    plhs[2] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_LogPYGivenK = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { _arg_N, _arg_D, _arg_K, _d[0]  };
    plhs[3] = mxCreateNumericArray(max((3 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_Mu = mxGetPr(plhs[3]);
  }
  {
    int _ds[] = { _arg_N, _arg_D, _arg_K, _d[0]  };
    plhs[4] = mxCreateNumericArray(max((3 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_RV = mxGetPr(plhs[4]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    GetSPMultiCompLogP(&_arg_LogPY[_arg_N*_vidx], &_arg_LogPKGivenY[_arg_N*_arg_K*_vidx], &_arg_LogPYGivenK[_arg_N*_arg_K*_vidx], &_arg_Mu[_arg_N*_arg_D*_arg_K*_vidx], &_arg_RV[_arg_N*_arg_D*_arg_K*_vidx], &_arg_DataMatr[_vecstride_DataMatr*_vidx], &_arg_NRepl[_vecstride_NRepl*_vidx], &_arg_CycleDep[_vecstride_CycleDep*_vidx], &_arg_NCycleDep[_vecstride_NCycleDep*_vidx], &_arg_PComp[_vecstride_PComp*_vidx], &_arg_CompType[_vecstride_CompType*_vidx], &_arg_PriorMu[_vecstride_PriorMu*_vidx], &_arg_PriorK0[_vecstride_PriorK0*_vidx], &_arg_PriorA1[_vecstride_PriorA1*_vidx], &_arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N, _arg_DNMaxRepl, _arg_D, _arg_T, _arg_K, _arg_NMaxCycleDep);
  }
}

void _wrap_IGammaGammaUpdatePosterior(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 2 ||
      nrhs != 4+1)
    mexErrMsgTxt("Wrong number of arguments to function IGammaGammaUpdatePosterior");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Observed;
  double *_arg_IGamA1;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  int _arg_D;
  _arg_N = (_dim(prhs[1], 0));
  _arg_D = (_dim(prhs[4], 0));
  int _vecstride_Observed = _arg_N*_arg_D;
  int _vecstride_IGamA1 = _arg_D;
  int _vecstride_PriorA1 = _arg_D;
  int _vecstride_PriorA2 = _arg_D;
  if (  (int)(_dim(prhs[1], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_Observed))
    mexErrMsgTxt("Error in dimension of argument Observed");
  if (mxIsDouble(prhs[1]))
    _arg_Observed = mxGetPr(prhs[1]);
  else
  {
    _arg_Observed = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Observed))
      mexErrMsgTxt("Expecting numeric matrix for argument Observed");
  }

  if (  (int)(_dim(prhs[2], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[2], &_vec_n, _d, 1, &_vecstride_IGamA1))
    mexErrMsgTxt("Error in dimension of argument IGamA1");
  if (mxIsDouble(prhs[2]))
    _arg_IGamA1 = mxGetPr(prhs[2]);
  else
  {
    _arg_IGamA1 = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_IGamA1))
      mexErrMsgTxt("Expecting numeric matrix for argument IGamA1");
  }

  if (  (int)(_dim(prhs[3], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[3], &_vec_n, _d, 1, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[3]))
    _arg_PriorA1 = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[4], &_vec_n, _d, 1, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[4]))
    _arg_PriorA2 = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[1]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    IGammaGammaUpdatePosterior(&_arg_PostA1[_arg_D*_vidx], &_arg_PostA2[_arg_D*_vidx], &_arg_Observed[_vecstride_Observed*_vidx], &_arg_IGamA1[_vecstride_IGamA1*_vidx], &_arg_PriorA1[_vecstride_PriorA1*_vidx], &_arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N, _arg_D);
  }
}

void _wrap_IGammaGammaUpdatePosterior1Dim(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 2 ||
      nrhs != 4+1)
    mexErrMsgTxt("Wrong number of arguments to function IGammaGammaUpdatePosterior1Dim");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Observed;
  double *_arg_IGamA1;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  _arg_N = (_dim(prhs[1], 0));
  int _vecstride_Observed = _arg_N;
  int _vecstride_IGamA1 = 1;
  int _vecstride_PriorA1 = 1;
  int _vecstride_PriorA2 = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 1, &_vecstride_Observed))
    mexErrMsgTxt("Error in dimension of argument Observed");
  if (mxIsDouble(prhs[1]))
    _arg_Observed = mxGetPr(prhs[1]);
  else
  {
    _arg_Observed = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Observed))
      mexErrMsgTxt("Expecting numeric matrix for argument Observed");
  }

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_IGamA1))
    mexErrMsgTxt("Error in dimension of argument IGamA1");
  if (mxIsDouble(prhs[2]))
    _arg_IGamA1 = mxGetPr(prhs[2]);
  else
  {
    _arg_IGamA1 = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_IGamA1))
      mexErrMsgTxt("Expecting numeric matrix for argument IGamA1");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[3]))
    _arg_PriorA1 = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[4], &_vec_n, _d, 0, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[4]))
    _arg_PriorA2 = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[1]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    IGammaGammaUpdatePosterior1Dim(&_arg_PostA1[1*_vidx], &_arg_PostA2[1*_vidx], &_arg_Observed[_vecstride_Observed*_vidx], _arg_IGamA1[_vecstride_IGamA1*_vidx], _arg_PriorA1[_vecstride_PriorA1*_vidx], _arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N);
  }
}

void _wrap_IGammaUpdatePosterior(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 2 ||
      nrhs != 3+1)
    mexErrMsgTxt("Wrong number of arguments to function IGammaUpdatePosterior");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Observed;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  int _arg_D;
  _arg_D = (_dim(prhs[3], 0));
  _arg_N = (_dim(prhs[1], 0));
  int _vecstride_Observed = _arg_N*_arg_D;
  int _vecstride_PriorA1 = _arg_D;
  int _vecstride_PriorA2 = _arg_D;
  if (  (int)(_dim(prhs[1], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_Observed))
    mexErrMsgTxt("Error in dimension of argument Observed");
  if (mxIsDouble(prhs[1]))
    _arg_Observed = mxGetPr(prhs[1]);
  else
  {
    _arg_Observed = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Observed))
      mexErrMsgTxt("Expecting numeric matrix for argument Observed");
  }

  if (  (int)(_dim(prhs[2], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[2], &_vec_n, _d, 1, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[2]))
    _arg_PriorA1 = mxGetPr(prhs[2]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 1, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[3]))
    _arg_PriorA2 = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[1]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    IGammaUpdatePosterior(&_arg_PostA1[_arg_D*_vidx], &_arg_PostA2[_arg_D*_vidx], &_arg_Observed[_vecstride_Observed*_vidx], &_arg_PriorA1[_vecstride_PriorA1*_vidx], &_arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N, _arg_D);
  }
}

void _wrap_IGammaUpdatePosterior1Dim(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 2 ||
      nrhs != 3+1)
    mexErrMsgTxt("Wrong number of arguments to function IGammaUpdatePosterior1Dim");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Observed;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  _arg_N = (_dim(prhs[1], 0));
  int _vecstride_Observed = _arg_N;
  int _vecstride_PriorA1 = 1;
  int _vecstride_PriorA2 = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 1, &_vecstride_Observed))
    mexErrMsgTxt("Error in dimension of argument Observed");
  if (mxIsDouble(prhs[1]))
    _arg_Observed = mxGetPr(prhs[1]);
  else
  {
    _arg_Observed = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Observed))
      mexErrMsgTxt("Expecting numeric matrix for argument Observed");
  }

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[2]))
    _arg_PriorA1 = mxGetPr(prhs[2]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[3]))
    _arg_PriorA2 = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[1]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    IGammaUpdatePosterior1Dim(&_arg_PostA1[1*_vidx], &_arg_PostA2[1*_vidx], &_arg_Observed[_vecstride_Observed*_vidx], _arg_PriorA1[_vecstride_PriorA1*_vidx], _arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N);
  }
}

void _wrap_NormalIGammaUpdatePosterior(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 4 ||
      nrhs != 5+1)
    mexErrMsgTxt("Wrong number of arguments to function NormalIGammaUpdatePosterior");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_PostMu;
  double *_arg_PostSc;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Data;
  double *_arg_PriorMu;
  double *_arg_PriorSc;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  int _arg_D;
  int _arg_GZ;
  _arg_GZ = (_dim(prhs[5], 0));
  _arg_N = (_dim(prhs[1], 0));
  _arg_D = (_dim(prhs[5], 1));
  int _vecstride_Data = _arg_N*_arg_D;
  int _vecstride_PriorMu = _arg_GZ*_arg_D;
  int _vecstride_PriorSc = _arg_GZ*_arg_D;
  int _vecstride_PriorA1 = _arg_GZ*_arg_D;
  int _vecstride_PriorA2 = _arg_GZ*_arg_D;
  if (  (int)(_dim(prhs[1], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_Data))
    mexErrMsgTxt("Error in dimension of argument Data");
  if (mxIsDouble(prhs[1]))
    _arg_Data = mxGetPr(prhs[1]);
  else
  {
    _arg_Data = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Data))
      mexErrMsgTxt("Expecting numeric matrix for argument Data");
  }

  if (  (int)(_dim(prhs[2], 0)) != (int)(_arg_GZ) ||
        (int)(_dim(prhs[2], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[2], &_vec_n, _d, 2, &_vecstride_PriorMu))
    mexErrMsgTxt("Error in dimension of argument PriorMu");
  if (mxIsDouble(prhs[2]))
    _arg_PriorMu = mxGetPr(prhs[2]);
  else
  {
    _arg_PriorMu = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_PriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorMu");
  }

  if (  (int)(_dim(prhs[3], 0)) != (int)(_arg_GZ) ||
        (int)(_dim(prhs[3], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[3], &_vec_n, _d, 2, &_vecstride_PriorSc))
    mexErrMsgTxt("Error in dimension of argument PriorSc");
  if (mxIsDouble(prhs[3]))
    _arg_PriorSc = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorSc = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorSc))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorSc");
  }

  if (  (int)(_dim(prhs[4], 0)) != (int)(_arg_GZ) ||
        (int)(_dim(prhs[4], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[4], &_vec_n, _d, 2, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[4]))
    _arg_PriorA1 = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[5], &_vec_n, _d, 2, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[5]))
    _arg_PriorA2 = mxGetPr(prhs[5]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { _arg_GZ, _arg_D, _d[0] , _d[1]  };
    plhs[0] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostMu = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_GZ, _arg_D, _d[0] , _d[1]  };
    plhs[1] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostSc = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _arg_GZ, _arg_D, _d[0] , _d[1]  };
    plhs[2] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { _arg_GZ, _arg_D, _d[0] , _d[1]  };
    plhs[3] = mxCreateNumericArray(max((2 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[3]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    NormalIGammaUpdatePosterior(&_arg_PostMu[_arg_GZ*_arg_D*_vidx], &_arg_PostSc[_arg_GZ*_arg_D*_vidx], &_arg_PostA1[_arg_GZ*_arg_D*_vidx], &_arg_PostA2[_arg_GZ*_arg_D*_vidx], &_arg_Data[_vecstride_Data*_vidx], &_arg_PriorMu[_vecstride_PriorMu*_vidx], &_arg_PriorSc[_vecstride_PriorSc*_vidx], &_arg_PriorA1[_vecstride_PriorA1*_vidx], &_arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N, _arg_D, _arg_GZ);
  }
}

void _wrap_NormalIGammaUpdatePosterior1Dim(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 4 ||
      nrhs != 5+1)
    mexErrMsgTxt("Wrong number of arguments to function NormalIGammaUpdatePosterior1Dim");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_PostMu;
  double *_arg_PostSc;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Data;
  double *_arg_PriorMu;
  double *_arg_PriorSc;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  _arg_N = (_dim(prhs[1], 0));
  int _vecstride_Data = _arg_N;
  int _vecstride_PriorMu = 1;
  int _vecstride_PriorSc = 1;
  int _vecstride_PriorA1 = 1;
  int _vecstride_PriorA2 = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 1, &_vecstride_Data))
    mexErrMsgTxt("Error in dimension of argument Data");
  if (mxIsDouble(prhs[1]))
    _arg_Data = mxGetPr(prhs[1]);
  else
  {
    _arg_Data = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Data))
      mexErrMsgTxt("Expecting numeric matrix for argument Data");
  }

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_PriorMu))
    mexErrMsgTxt("Error in dimension of argument PriorMu");
  if (mxIsDouble(prhs[2]))
    _arg_PriorMu = mxGetPr(prhs[2]);
  else
  {
    _arg_PriorMu = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_PriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorMu");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_PriorSc))
    mexErrMsgTxt("Error in dimension of argument PriorSc");
  if (mxIsDouble(prhs[3]))
    _arg_PriorSc = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorSc = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorSc))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorSc");
  }

  if (!_check_input_vectorize(prhs[4], &_vec_n, _d, 0, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[4]))
    _arg_PriorA1 = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[5], &_vec_n, _d, 0, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[5]))
    _arg_PriorA2 = mxGetPr(prhs[5]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostMu = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostSc = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[2] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { 1, _d[0] , _d[1] , _d[2]  };
    plhs[3] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[3]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    NormalIGammaUpdatePosterior1Dim(&_arg_PostMu[1*_vidx], &_arg_PostSc[1*_vidx], &_arg_PostA1[1*_vidx], &_arg_PostA2[1*_vidx], &_arg_Data[_vecstride_Data*_vidx], _arg_PriorMu[_vecstride_PriorMu*_vidx], _arg_PriorSc[_vecstride_PriorSc*_vidx], _arg_PriorA1[_vecstride_PriorA1*_vidx], _arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N);
  }
}

void _wrap_NormalIGammaUpdatePosteriorGZ1(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 4 ||
      nrhs != 5+1)
    mexErrMsgTxt("Wrong number of arguments to function NormalIGammaUpdatePosteriorGZ1");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_PostMu;
  double *_arg_PostSc;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Data;
  double *_arg_PriorMu;
  double *_arg_PriorSc;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  int _arg_D;
  _arg_N = (_dim(prhs[1], 0));
  _arg_D = (_dim(prhs[5], 0));
  int _vecstride_Data = _arg_N*_arg_D;
  int _vecstride_PriorMu = _arg_D;
  int _vecstride_PriorSc = _arg_D;
  int _vecstride_PriorA1 = _arg_D;
  int _vecstride_PriorA2 = _arg_D;
  if (  (int)(_dim(prhs[1], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_Data))
    mexErrMsgTxt("Error in dimension of argument Data");
  if (mxIsDouble(prhs[1]))
    _arg_Data = mxGetPr(prhs[1]);
  else
  {
    _arg_Data = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Data))
      mexErrMsgTxt("Expecting numeric matrix for argument Data");
  }

  if (  (int)(_dim(prhs[2], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[2], &_vec_n, _d, 1, &_vecstride_PriorMu))
    mexErrMsgTxt("Error in dimension of argument PriorMu");
  if (mxIsDouble(prhs[2]))
    _arg_PriorMu = mxGetPr(prhs[2]);
  else
  {
    _arg_PriorMu = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_PriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorMu");
  }

  if (  (int)(_dim(prhs[3], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[3], &_vec_n, _d, 1, &_vecstride_PriorSc))
    mexErrMsgTxt("Error in dimension of argument PriorSc");
  if (mxIsDouble(prhs[3]))
    _arg_PriorSc = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorSc = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorSc))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorSc");
  }

  if (  (int)(_dim(prhs[4], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[4], &_vec_n, _d, 1, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[4]))
    _arg_PriorA1 = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[5], &_vec_n, _d, 1, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[5]))
    _arg_PriorA2 = mxGetPr(prhs[5]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostMu = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostSc = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[2] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[3] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[3]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    NormalIGammaUpdatePosteriorGZ1(&_arg_PostMu[_arg_D*_vidx], &_arg_PostSc[_arg_D*_vidx], &_arg_PostA1[_arg_D*_vidx], &_arg_PostA2[_arg_D*_vidx], &_arg_Data[_vecstride_Data*_vidx], &_arg_PriorMu[_vecstride_PriorMu*_vidx], &_arg_PriorSc[_vecstride_PriorSc*_vidx], &_arg_PriorA1[_vecstride_PriorA1*_vidx], &_arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N, _arg_D);
  }
}

void _wrap_NormalIGammaUpdatePosteriorS(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs != 4 ||
      nrhs != 6+1)
    mexErrMsgTxt("Wrong number of arguments to function NormalIGammaUpdatePosteriorS");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  double *_arg_PostMu;
  double *_arg_PostSc;
  double *_arg_PostA1;
  double *_arg_PostA2;
  double *_arg_Data;
  double *_arg_DataIdx;
  double *_arg_PriorMu;
  double *_arg_PriorSc;
  double *_arg_PriorA1;
  double *_arg_PriorA2;
  int _arg_N;
  int _arg_D;
  int _arg_NIdx;
  _arg_N = (_dim(prhs[1], 0));
  _arg_NIdx = (_dim(prhs[2], 0));
  _arg_D = (_dim(prhs[6], 0));
  int _vecstride_Data = _arg_N*_arg_D;
  int _vecstride_DataIdx = _arg_NIdx;
  int _vecstride_PriorMu = _arg_D;
  int _vecstride_PriorSc = _arg_D;
  int _vecstride_PriorA1 = _arg_D;
  int _vecstride_PriorA2 = _arg_D;
  if (  (int)(_dim(prhs[1], 1)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[1], &_vec_n, _d, 2, &_vecstride_Data))
    mexErrMsgTxt("Error in dimension of argument Data");
  if (mxIsDouble(prhs[1]))
    _arg_Data = mxGetPr(prhs[1]);
  else
  {
    _arg_Data = MEM_ALLOC(double *, _arraylen(prhs[1]), sizeof (double));
    if (!_get_numeric(prhs[1], _arg_Data))
      mexErrMsgTxt("Expecting numeric matrix for argument Data");
  }

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 1, &_vecstride_DataIdx))
    mexErrMsgTxt("Error in dimension of argument DataIdx");
  if (mxIsDouble(prhs[2]))
    _arg_DataIdx = mxGetPr(prhs[2]);
  else
  {
    _arg_DataIdx = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_DataIdx))
      mexErrMsgTxt("Expecting numeric matrix for argument DataIdx");
  }

  if (  (int)(_dim(prhs[3], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[3], &_vec_n, _d, 1, &_vecstride_PriorMu))
    mexErrMsgTxt("Error in dimension of argument PriorMu");
  if (mxIsDouble(prhs[3]))
    _arg_PriorMu = mxGetPr(prhs[3]);
  else
  {
    _arg_PriorMu = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_PriorMu))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorMu");
  }

  if (  (int)(_dim(prhs[4], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[4], &_vec_n, _d, 1, &_vecstride_PriorSc))
    mexErrMsgTxt("Error in dimension of argument PriorSc");
  if (mxIsDouble(prhs[4]))
    _arg_PriorSc = mxGetPr(prhs[4]);
  else
  {
    _arg_PriorSc = MEM_ALLOC(double *, _arraylen(prhs[4]), sizeof (double));
    if (!_get_numeric(prhs[4], _arg_PriorSc))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorSc");
  }

  if (  (int)(_dim(prhs[5], 0)) != (int)(_arg_D) ||
      !_check_input_vectorize(prhs[5], &_vec_n, _d, 1, &_vecstride_PriorA1))
    mexErrMsgTxt("Error in dimension of argument PriorA1");
  if (mxIsDouble(prhs[5]))
    _arg_PriorA1 = mxGetPr(prhs[5]);
  else
  {
    _arg_PriorA1 = MEM_ALLOC(double *, _arraylen(prhs[5]), sizeof (double));
    if (!_get_numeric(prhs[5], _arg_PriorA1))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA1");
  }

  if (!_check_input_vectorize(prhs[6], &_vec_n, _d, 1, &_vecstride_PriorA2))
    mexErrMsgTxt("Error in dimension of argument PriorA2");
  if (mxIsDouble(prhs[6]))
    _arg_PriorA2 = mxGetPr(prhs[6]);
  else
  {
    _arg_PriorA2 = MEM_ALLOC(double *, _arraylen(prhs[6]), sizeof (double));
    if (!_get_numeric(prhs[6], _arg_PriorA2))
      mexErrMsgTxt("Expecting numeric matrix for argument PriorA2");
  }

  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[0] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostMu = mxGetPr(plhs[0]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[1] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostSc = mxGetPr(plhs[1]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[2] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA1 = mxGetPr(plhs[2]);
  }
  {
    int _ds[] = { _arg_D, _d[0] , _d[1] , _d[2]  };
    plhs[3] = mxCreateNumericArray(max((1 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxREAL);
    _arg_PostA2 = mxGetPr(plhs[3]);
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    NormalIGammaUpdatePosteriorS(&_arg_PostMu[_arg_D*_vidx], &_arg_PostSc[_arg_D*_vidx], &_arg_PostA1[_arg_D*_vidx], &_arg_PostA2[_arg_D*_vidx], &_arg_Data[_vecstride_Data*_vidx], &_arg_DataIdx[_vecstride_DataIdx*_vidx], &_arg_PriorMu[_vecstride_PriorMu*_vidx], &_arg_PriorSc[_vecstride_PriorSc*_vidx], &_arg_PriorA1[_vecstride_PriorA1*_vidx], &_arg_PriorA2[_vecstride_PriorA2*_vidx], _arg_N, _arg_D, _arg_NIdx);
  }
}

void _wrap_Distrib_DLogDensity(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 5+1)
    mexErrMsgTxt("Wrong number of arguments to function Distrib_DLogDensity");
  Distrib * _arg_THIS;
  double _arg_Y;
  double _arg_X;
  int _arg_m;
  int _arg_n;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument THIS");

  if (_n_dims(prhs[2]) > 0)
    mexErrMsgTxt("Error in dimension of argument Y");
  if (!_get_numeric(prhs[2], &_arg_Y))
    mexErrMsgTxt("Expecting numeric scalar for argument Y");

  if (_n_dims(prhs[3]) > 0)
    mexErrMsgTxt("Error in dimension of argument X");
  if (!_get_numeric(prhs[3], &_arg_X))
    mexErrMsgTxt("Expecting numeric scalar for argument X");

  if (_n_dims(prhs[4]) > 0)
    mexErrMsgTxt("Error in dimension of argument m");
  if (!_get_numeric(prhs[4], &_arg_m))
    mexErrMsgTxt("Expecting numeric scalar for argument m");

  if (_n_dims(prhs[5]) > 0)
    mexErrMsgTxt("Error in dimension of argument n");
  if (!_get_numeric(prhs[5], &_arg_n))
    mexErrMsgTxt("Expecting numeric scalar for argument n");

    (_arg_THIS)->DLogDensity(&_arg_Y, &_arg_X, _arg_m, _arg_n);
}

void _wrap_Distrib_LogDensity(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 5+1)
    mexErrMsgTxt("Wrong number of arguments to function Distrib_LogDensity");
  Distrib * _arg_THIS;
  double _arg_Y;
  double _arg_X;
  int _arg_m;
  int _arg_n;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument THIS");

  if (_n_dims(prhs[2]) > 0)
    mexErrMsgTxt("Error in dimension of argument Y");
  if (!_get_numeric(prhs[2], &_arg_Y))
    mexErrMsgTxt("Expecting numeric scalar for argument Y");

  if (_n_dims(prhs[3]) > 0)
    mexErrMsgTxt("Error in dimension of argument X");
  if (!_get_numeric(prhs[3], &_arg_X))
    mexErrMsgTxt("Expecting numeric scalar for argument X");

  if (_n_dims(prhs[4]) > 0)
    mexErrMsgTxt("Error in dimension of argument m");
  if (!_get_numeric(prhs[4], &_arg_m))
    mexErrMsgTxt("Expecting numeric scalar for argument m");

  if (_n_dims(prhs[5]) > 0)
    mexErrMsgTxt("Error in dimension of argument n");
  if (!_get_numeric(prhs[5], &_arg_n))
    mexErrMsgTxt("Expecting numeric scalar for argument n");

    (_arg_THIS)->LogDensity(&_arg_Y, &_arg_X, _arg_m, _arg_n);
}

void _wrap_Distrib_delete(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function Distrib_delete");
  Distrib * _arg_THIS;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument THIS");

    delete _arg_THIS;
}

void _wrap_Distrib_new(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 3+1)
    mexErrMsgTxt("Wrong number of arguments to function Distrib_new");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  int *_arg_type_;
  double *_arg_mean_;
  double *_arg_sigmasq_;
  Distrib * *_arg_retval;
  int _vecstride_type_ = 1;
  int _vecstride_mean_ = 1;
  int _vecstride_sigmasq_ = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_type_))
    mexErrMsgTxt("Error in dimension of argument type_");
  if (mxIsInt32(prhs[1]) || mxIsUint32(prhs[1]))
    _arg_type_ = (int *)mxGetData(prhs[1]);
  else
  {
    _arg_type_ = MEM_ALLOC(int *, _arraylen(prhs[1]), sizeof (int));
    if (!_get_numeric(prhs[1], _arg_type_))
      mexErrMsgTxt("Expecting numeric matrix for argument type_");
  }

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_mean_))
    mexErrMsgTxt("Error in dimension of argument mean_");
  if (mxIsDouble(prhs[2]))
    _arg_mean_ = mxGetPr(prhs[2]);
  else
  {
    _arg_mean_ = MEM_ALLOC(double *, _arraylen(prhs[2]), sizeof (double));
    if (!_get_numeric(prhs[2], _arg_mean_))
      mexErrMsgTxt("Expecting numeric matrix for argument mean_");
  }

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_sigmasq_))
    mexErrMsgTxt("Error in dimension of argument sigmasq_");
  if (mxIsDouble(prhs[3]))
    _arg_sigmasq_ = mxGetPr(prhs[3]);
  else
  {
    _arg_sigmasq_ = MEM_ALLOC(double *, _arraylen(prhs[3]), sizeof (double));
    if (!_get_numeric(prhs[3], _arg_sigmasq_))
      mexErrMsgTxt("Expecting numeric matrix for argument sigmasq_");
  }

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxCOMPLEX);
    _arg_retval = MEM_ALLOC(Distrib * *, _arraylen(plhs[0]), sizeof (Distrib *));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (Distrib *)
      new Distrib(_arg_type_[_vecstride_type_*_vidx], _arg_mean_[_vecstride_mean_*_vidx], _arg_sigmasq_[_vecstride_sigmasq_*_vidx]);
  }
  _put_pointer(plhs[0], (void **)_arg_retval, 102363); /* Distrib * */
}

void _wrap_Distrib_sample(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 3+1)
    mexErrMsgTxt("Wrong number of arguments to function Distrib_sample");
  Distrib * _arg_THIS;
  double _arg_y;
  int _arg_n;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument THIS");

  if (_n_dims(prhs[2]) > 0)
    mexErrMsgTxt("Error in dimension of argument y");
  if (!_get_numeric(prhs[2], &_arg_y))
    mexErrMsgTxt("Expecting numeric scalar for argument y");

  if (_n_dims(prhs[3]) > 0)
    mexErrMsgTxt("Error in dimension of argument n");
  if (!_get_numeric(prhs[3], &_arg_n))
    mexErrMsgTxt("Expecting numeric scalar for argument n");

    (_arg_THIS)->sample(&_arg_y, _arg_n);
}

void _wrap_PriorInfo_get_A(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function PriorInfo_get_A");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  PriorInfo * *_arg_THIS;
  Distrib * *_arg_retval;
  int _vecstride_THIS = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(PriorInfo * *, _arraylen(prhs[1]), sizeof (PriorInfo *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 250386)) /* PriorInfo * */
    mexErrMsgTxt("Wrong pointer type, expecting PriorInfo * for argument THIS");

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxCOMPLEX);
    _arg_retval = MEM_ALLOC(Distrib * *, _arraylen(plhs[0]), sizeof (Distrib *));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (Distrib *)
      (_arg_THIS[_vecstride_THIS*_vidx])->A;
  }
  _put_pointer(plhs[0], (void **)_arg_retval, 102363); /* Distrib * */
}

void _wrap_PriorInfo_set_A(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 2+1)
    mexErrMsgTxt("Wrong number of arguments to function PriorInfo_set_A");
  PriorInfo * _arg_THIS;
  Distrib * _arg_newval;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 250386)) /* PriorInfo * */
    mexErrMsgTxt("Wrong pointer type, expecting PriorInfo * for argument THIS");

  if (_n_dims(prhs[2]) > 0)
    mexErrMsgTxt("Error in dimension of argument newval");
  if (!_get_pointer((void **)&_arg_newval, prhs[2], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument newval");

    (_arg_THIS)->A = _arg_newval;
}

void _wrap_PriorInfo_get_L(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function PriorInfo_get_L");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  PriorInfo * *_arg_THIS;
  Distrib * *_arg_retval;
  int _vecstride_THIS = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(PriorInfo * *, _arraylen(prhs[1]), sizeof (PriorInfo *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 250386)) /* PriorInfo * */
    mexErrMsgTxt("Wrong pointer type, expecting PriorInfo * for argument THIS");

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxCOMPLEX);
    _arg_retval = MEM_ALLOC(Distrib * *, _arraylen(plhs[0]), sizeof (Distrib *));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (Distrib *)
      (_arg_THIS[_vecstride_THIS*_vidx])->L;
  }
  _put_pointer(plhs[0], (void **)_arg_retval, 102363); /* Distrib * */
}

void _wrap_PriorInfo_set_L(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 2+1)
    mexErrMsgTxt("Wrong number of arguments to function PriorInfo_set_L");
  PriorInfo * _arg_THIS;
  Distrib * _arg_newval;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 250386)) /* PriorInfo * */
    mexErrMsgTxt("Wrong pointer type, expecting PriorInfo * for argument THIS");

  if (_n_dims(prhs[2]) > 0)
    mexErrMsgTxt("Error in dimension of argument newval");
  if (!_get_pointer((void **)&_arg_newval, prhs[2], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument newval");

    (_arg_THIS)->L = _arg_newval;
}

void _wrap_PriorInfo_get_W(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function PriorInfo_get_W");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  PriorInfo * *_arg_THIS;
  Distrib * *_arg_retval;
  int _vecstride_THIS = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_THIS))
    mexErrMsgTxt("Error in dimension of argument THIS");
  _arg_THIS =
    MEM_ALLOC(PriorInfo * *, _arraylen(prhs[1]), sizeof (PriorInfo *));
  if (!_get_pointer((void **)_arg_THIS, prhs[1], 250386)) /* PriorInfo * */
    mexErrMsgTxt("Wrong pointer type, expecting PriorInfo * for argument THIS");

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxCOMPLEX);
    _arg_retval = MEM_ALLOC(Distrib * *, _arraylen(plhs[0]), sizeof (Distrib *));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (Distrib *)
      (_arg_THIS[_vecstride_THIS*_vidx])->W;
  }
  _put_pointer(plhs[0], (void **)_arg_retval, 102363); /* Distrib * */
}

void _wrap_PriorInfo_set_W(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 2+1)
    mexErrMsgTxt("Wrong number of arguments to function PriorInfo_set_W");
  PriorInfo * _arg_THIS;
  Distrib * _arg_newval;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 250386)) /* PriorInfo * */
    mexErrMsgTxt("Wrong pointer type, expecting PriorInfo * for argument THIS");

  if (_n_dims(prhs[2]) > 0)
    mexErrMsgTxt("Error in dimension of argument newval");
  if (!_get_pointer((void **)&_arg_newval, prhs[2], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument newval");

    (_arg_THIS)->W = _arg_newval;
}

void _wrap_PriorInfo_delete(int nlhs, mxArray **, int nrhs, const mxArray **prhs)
{
  if (nlhs != 0 ||
      nrhs != 1+1)
    mexErrMsgTxt("Wrong number of arguments to function PriorInfo_delete");
  PriorInfo * _arg_THIS;
  if (_n_dims(prhs[1]) > 0)
    mexErrMsgTxt("Error in dimension of argument THIS");
  if (!_get_pointer((void **)&_arg_THIS, prhs[1], 250386)) /* PriorInfo * */
    mexErrMsgTxt("Wrong pointer type, expecting PriorInfo * for argument THIS");

    delete _arg_THIS;
}

void _wrap_PriorInfo_new(int nlhs, mxArray **plhs, int nrhs, const mxArray **prhs)
{
  if (nlhs > 1 ||
      nrhs != 3+1)
    mexErrMsgTxt("Wrong number of arguments to function PriorInfo_new");
  int _d[4] = { 1,1,1,1 };
  int _vec_n = 0;
  int _vidx;
  int _vec_sz;
  Distrib * *_arg_W_;
  Distrib * *_arg_A_;
  Distrib * *_arg_L_;
  PriorInfo * *_arg_retval;
  int _vecstride_W_ = 1;
  int _vecstride_A_ = 1;
  int _vecstride_L_ = 1;
  if (!_check_input_vectorize(prhs[1], &_vec_n, _d, 0, &_vecstride_W_))
    mexErrMsgTxt("Error in dimension of argument W_");
  _arg_W_ =
    MEM_ALLOC(Distrib * *, _arraylen(prhs[1]), sizeof (Distrib *));
  if (!_get_pointer((void **)_arg_W_, prhs[1], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument W_");

  if (!_check_input_vectorize(prhs[2], &_vec_n, _d, 0, &_vecstride_A_))
    mexErrMsgTxt("Error in dimension of argument A_");
  _arg_A_ =
    MEM_ALLOC(Distrib * *, _arraylen(prhs[2]), sizeof (Distrib *));
  if (!_get_pointer((void **)_arg_A_, prhs[2], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument A_");

  if (!_check_input_vectorize(prhs[3], &_vec_n, _d, 0, &_vecstride_L_))
    mexErrMsgTxt("Error in dimension of argument L_");
  _arg_L_ =
    MEM_ALLOC(Distrib * *, _arraylen(prhs[3]), sizeof (Distrib *));
  if (!_get_pointer((void **)_arg_L_, prhs[3], 102363)) /* Distrib * */
    mexErrMsgTxt("Wrong pointer type, expecting Distrib * for argument L_");

  {
    int _ds[] = { _d[0] , _d[1] , _d[2] , _d[3]  };
    plhs[0] = mxCreateNumericArray(max((0 + _vec_n), 2), _ds, mxDOUBLE_CLASS, mxCOMPLEX);
    _arg_retval = MEM_ALLOC(PriorInfo * *, _arraylen(plhs[0]), sizeof (PriorInfo *));
  }
  _vec_sz = _d[0]*_d[1]*_d[2]*_d[3];
  for (_vidx = 0; _vidx < _vec_sz; ++_vidx) {
    _arg_retval[_vidx] = (PriorInfo *)
      new PriorInfo(_arg_W_[_vecstride_W_*_vidx], _arg_A_[_vecstride_A_*_vidx], _arg_L_[_vecstride_L_*_vidx]);
  }
  _put_pointer(plhs[0], (void **)_arg_retval, 250386); /* PriorInfo * */
}



/*
 * The main dispatch function.  This function calls the appropriate wrapper
 * based on the value of the first argument.
 */

#ifdef __cplusplus
extern "C" {
#endif

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
  if (nrhs == 0 || !mxIsDouble(prhs[0]) ||
      mxGetM(prhs[0]) != 1 || mxGetN(prhs[0]) != 1)
    mexErrMsgTxt("Illegal call to mex functions in NIGPeriodic_wrap");
  switch ((int)(mxGetScalar(prhs[0]))) {
  case 0: _wrap_GetLogPYNormalIGamma(nlhs, plhs, nrhs, prhs); break;
  case 1: _wrap_GetLogPYNormalIGamma1Dim(nlhs, plhs, nrhs, prhs); break;
  case 2: _wrap_GetLogPYNormalIGammaGZ1(nlhs, plhs, nrhs, prhs); break;
  case 3: _wrap_GetSPLogP(nlhs, plhs, nrhs, prhs); break;
  case 4: _wrap_GetSPMultiCompLogP(nlhs, plhs, nrhs, prhs); break;
  case 5: _wrap_IGammaGammaUpdatePosterior(nlhs, plhs, nrhs, prhs); break;
  case 6: _wrap_IGammaGammaUpdatePosterior1Dim(nlhs, plhs, nrhs, prhs); break;
  case 7: _wrap_IGammaUpdatePosterior(nlhs, plhs, nrhs, prhs); break;
  case 8: _wrap_IGammaUpdatePosterior1Dim(nlhs, plhs, nrhs, prhs); break;
  case 9: _wrap_NormalIGammaUpdatePosterior(nlhs, plhs, nrhs, prhs); break;
  case 10: _wrap_NormalIGammaUpdatePosterior1Dim(nlhs, plhs, nrhs, prhs); break;
  case 11: _wrap_NormalIGammaUpdatePosteriorGZ1(nlhs, plhs, nrhs, prhs); break;
  case 12: _wrap_NormalIGammaUpdatePosteriorS(nlhs, plhs, nrhs, prhs); break;
  case 13: _wrap_Distrib_DLogDensity(nlhs, plhs, nrhs, prhs); break;
  case 14: _wrap_Distrib_LogDensity(nlhs, plhs, nrhs, prhs); break;
  case 15: _wrap_Distrib_delete(nlhs, plhs, nrhs, prhs); break;
  case 16: _wrap_Distrib_new(nlhs, plhs, nrhs, prhs); break;
  case 17: _wrap_Distrib_sample(nlhs, plhs, nrhs, prhs); break;
  case 18: _wrap_PriorInfo_get_A(nlhs, plhs, nrhs, prhs); break;
  case 19: _wrap_PriorInfo_set_A(nlhs, plhs, nrhs, prhs); break;
  case 20: _wrap_PriorInfo_get_L(nlhs, plhs, nrhs, prhs); break;
  case 21: _wrap_PriorInfo_set_L(nlhs, plhs, nrhs, prhs); break;
  case 22: _wrap_PriorInfo_get_W(nlhs, plhs, nrhs, prhs); break;
  case 23: _wrap_PriorInfo_set_W(nlhs, plhs, nrhs, prhs); break;
  case 24: _wrap_PriorInfo_delete(nlhs, plhs, nrhs, prhs); break;
  case 25: _wrap_PriorInfo_new(nlhs, plhs, nrhs, prhs); break;

  default: mexErrMsgTxt("Illegal function ID parameter");
  }
}

#ifdef __cplusplus
}
#endif
