#ifndef NORMALIGAMMA_H_
#define NORMALIGAMMA_H_

//#ifdef __cplusplus
//extern "C" {
//#endif

void NormalIGammaUpdatePosterior1Dim(numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, const numtype *Data, numtype PriorMu, numtype PriorSc, numtype PriorA1, numtype PriorA2, const int N);
//%output PostMu(1) 
//%output PostSc(1)
//%output PostA1(1)
//%output PostA2(1)
//%input  Data(N)
//%input  PriorMu
//%input  PriorSc
//%input  PriorA1
//%input  PriorA2

void NormalIGammaUpdatePosterior(numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, const numtype *Data, const numtype *PriorMu, const numtype *PriorSc, const numtype *PriorA1, const numtype *PriorA2, const int N, const int D, const int GZ);
//%output PostMu(GZ,D) 
//%output PostSc(GZ,D)
//%output PostA1(GZ,D)
//%output PostA2(GZ,D)
//%input  Data(N,D)
//%input  PriorMu(GZ,D)
//%input  PriorSc(GZ,D)
//%input  PriorA1(GZ,D)
//%input  PriorA2(GZ,D)

void NormalIGammaUpdatePosteriorGZ1(numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, const numtype *Data, const numtype *PriorMu, const numtype *PriorSc, const numtype *PriorA1, const numtype *PriorA2, const int N, const int D);
//%output PostMu(D) 
//%output PostSc(D)
//%output PostA1(D)
//%output PostA2(D)
//%input  Data(N,D)
//%input  PriorMu(D)
//%input  PriorSc(D)
//%input  PriorA1(D)
//%input  PriorA2(D)

void NormalIGammaUpdatePosteriorS(numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, const numtype *Data, const numtype *DataIdx, const numtype *PriorMu, const numtype *PriorSc, const numtype *PriorA1, const numtype *PriorA2, const int N, const int D, const int NIdx);
//%output PostMu(D) 
//%output PostSc(D)
//%output PostA1(D)
//%output PostA2(D)
//%input  Data(N,D)
//%input  DataIdx(NIdx)
//%input  PriorMu(D)
//%input  PriorSc(D)
//%input  PriorA1(D)
//%input  PriorA2(D)


void IGammaUpdatePosterior1Dim(numtype *PostA1, numtype *PostA2, const numtype *Observed, const numtype PriorA1, const numtype PriorA2,int N);
//%output PostA1(1)
//%output PostA2(1)
//%input  Observed(N)
//%input  PriorA1
//%input  PriorA2

void IGammaUpdatePosterior(numtype *PostA1, numtype *PostA2, const numtype *Observed, const numtype *PriorA1, const numtype *PriorA2,int N, int D);
//%output PostA1(D)
//%output PostA2(D)
//%input  Observed(N,D)
//%input  PriorA1(D)
//%input  PriorA2(D)

void IGammaGammaUpdatePosterior1Dim(numtype *PostA1, numtype *PostA2, const numtype *Observed, const numtype IGamA1, const numtype PriorA1, const numtype PriorA2,int N);
//%output PostA1(1)
//%output PostA2(1)
//%input  Observed(N)
//%input  IGamA1
//%input  PriorA1
//%input  PriorA2

void IGammaGammaUpdatePosterior(numtype *PostA1, numtype *PostA2, const numtype *Observed, const numtype *IGamA1, const numtype *PriorA1, const numtype *PriorA2,int N, int D);
//%output PostA1(D)
//%output PostA2(D)
//%input  Observed(N,D)
//%input  IGamA1(D)
//%input  PriorA1(D)
//%input  PriorA2(D)


void GetLogPYNormalIGamma1Dim(numtype *LogPY, numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, const numtype *Data, numtype PriorMu, numtype PriorSc, numtype PriorA1, numtype PriorA2, const int N);
//%output LogPY(1) 
//%output PostMu(1) 
//%output PostSc(1)
//%output PostA1(1)
//%output PostA2(1)
//%input  Data(N)
//%input  PriorMu
//%input  PriorSc
//%input  PriorA1
//%input  PriorA2
 
void GetLogPYNormalIGamma(numtype *LogPY, numtype *LogPYGivenZ, numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, numtype *PostZ, const numtype *Data, const numtype *PriorMu, const numtype *PriorSc, const numtype *PriorA1, const numtype *PriorA2, const numtype *PriorPZ, const int N, const int D, const int GZ);
//%output LogPY(1) 
//%output LogPYGivenZ(GZ) 
//%output PostMu(GZ,D) 
//%output PostSc(GZ,D)
//%output PostA1(GZ,D)
//%output PostA2(GZ,D)
//%output PostZ(GZ)
//%input  Data(N,D)
//%input  PriorMu(GZ,D)
//%input  PriorSc(GZ,D)
//%input  PriorA1(GZ,D)
//%input  PriorA2(GZ,D)
//%input  PriorPZ(GZ)

void GetLogPYNormalIGammaGZ1(numtype *LogPY, numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, const numtype *Data, const numtype *PriorMu, const numtype *PriorSc, const numtype *PriorA1, const numtype *PriorA2, const int N, const int D);
//%output LogPY(1) 
//%output PostMu(D) 
//%output PostSc(D)
//%output PostA1(D)
//%output PostA2(D)
//%input  Data(N,D)
//%input  PriorMu(D)
//%input  PriorSc(D)
//%input  PriorA1(D)
//%input  PriorA2(D)
/*
void GetLogPYNormalIGammaClustRepl(numtype *LogPY, numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, const numtype *Data, const numtype *NRepl, const numtype *PriorMu, const numtype *PriorSc, const numtype *PriorA1, const numtype *PriorA2, const numtype *Z, const int K, const int N, const int D, const int DNMaxRepl);
//%output LogPY(K) 
//%output PostMu(K,D) 
//%output PostSc(K,D)
//%output PostA1(K,D)
//%output PostA2(K,D)
//%input  Data(N,DNMaxRepl)
//%input  NRepl(N,D)
//%input  PriorMu(K,D)
//%input  PriorSc(K,D)
//%input  PriorA1(K,D)
//%input  PriorA2(K,D)
//%input  Z(N)

void GetLogPYNormalIGammaReplClustS(numtype *LogPY, numtype *PostMu, numtype *PostSc, numtype *PostA1, numtype *PostA2, const numtype *Data, const numtype *NRepl, const numtype *PriorMu, const numtype *PriorSc, const numtype *PriorA1, const numtype *PriorA2, const numtype *Z, const int K, const int N, const int D, const int DNMaxRepl);
//%output LogPY(K) 
//%output PostMu(K,D) 
//%output PostSc(K,D)
//%output PostA1(K,D)
//%output PostA2(K,D)
//%input  Data(N,DNMaxRepl)
//%input  NRepl(N,D)
//%input  PriorMu(K,D)
//%input  PriorSc(K,D)
//%input  PriorA1(K,D)
//%input  PriorA2(K,D)
//%input  Z(N)

void GetLogPYNormalIGammaReplS(numtype *LogPY, numtype *LogPKGivenY, const numtype *Data, const numtype *NRepl, const numtype *PriorMu, const numtype *PriorSc, const numtype *PriorA1, const numtype *PriorA2, const numtype *PK, const int K, const int N, const int D, const int DNMaxRepl);
//%output LogPY(K) 
//%output LogPKGivenY(N,K) 
//%input  Data(N,DNMaxRepl)
//%input  NRepl(N,D)
//%input  PriorMu(K,D)
//%input  PriorSc(K,D)
//%input  PriorA1(K,D)
//%input  PriorA2(K,D)
//%input  PK(K)
*/
//#ifdef __cplusplus
//}
//#endif

#endif
