#ifndef MF_UPDPOST_H_
#define MF_UPDPOST_H_

//#ifdef __cplusplus
//extern "C" {
//#endif

void MFInvGammaUpdatePosterior (numtype *PosteriorA, numtype *PosteriorB, const numtype *Data, const numtype *NRepl, const numtype *Mu, const numtype *Dims, const numtype *PriorA, const numtype *PriorB, const int D, const int NDims, const int DNMaxRepl);
//%output PosteriorA(1)
//%output PosteriorB(1)
//%input  Data(DNMaxRepl)
//%input  NRepl(D)
//%input  Mu(D)
//%input  Dims(NDims)
//%input  PriorA
//%input  PriorB

void MFInvGammaUpdatePosteriorBatch (numtype *ReplVar, numtype *Posterior,const numtype *Data, const numtype *NRepl, const numtype *Mu, const numtype *ReplVarOld, const numtype *ReplVarGroups, const numtype *ReplVarGroupLen, const numtype *PriorA, const numtype *PriorB, const int D, const int NReplVarGroups, const int NMaxGroupLen, const int DNMaxRepl);
//%output ReplVar(D)
//%output Posterior(NReplVarGroups, 2)
//%input  Data(DNMaxRepl)
//%input  NRepl(D)
//%input  Mu(D)
//%input  ReplVarOld(D)
//%input  ReplVarGroups(NReplVarGroups,NMaxGroupLen)
//%input  ReplVarGroupLen(NReplVarGroups)
//%input  PriorA
//%input  PriorB

void MFNormalFVUpdatePosterior1 (numtype *PosteriorMean,numtype *PosteriorVar, const numtype *Observed, const numtype FixedVar, const numtype NObserved,const numtype PriorMean,const numtype PriorVar);
//%output PosteriorMean(1)
//%output PosteriorVar(1)
//%input  Observed(NObserved)
//%input  FixedVar
//%input  NObserved
//%input  PriorMean
//%input  PriorVar


void MFNormalFVUpdatePosterior (numtype *PosteriorMean,numtype *PosteriorVar, const numtype *Observed, const numtype *FixedVar, const numtype *NObserved,const numtype *PriorMean,const numtype *PriorVar, const int NMaxObserved,	const int D,const int NFixedVar);
//%output PosteriorMean(D)
//%output PosteriorVar(D)
//%input  Observed(NMaxObserved, D, NFixedVar)
//%input  FixedVar(D,NFixedVar)
//%input  NObserved(NFixedVar,1)
//%input  PriorMean(D)
//%input  PriorVar(D) 


void MFNormalFVKUpdatePosterior (numtype *PosteriorMean,numtype *PosteriorVar, const numtype *Observed, const numtype FixedVar, const numtype KFactor, const numtype PriorMean,const numtype PriorVar, const int NObserved);
//%output PosteriorMean(1)
//%output PosteriorVar(1)
//%input  Observed(NObserved)
//%input  FixedVar
//%input  KFactor
//%input  PriorMean
//%input  PriorVar 

void MFNormalFVKVUpdatePosterior (numtype *PosteriorMean,numtype *PosteriorVar, const numtype *Observed, const numtype FixedVar, const numtype KFactor, const numtype PriorMean,const numtype PriorVar, const int NObserved);
//%output PosteriorMean(1)
//%output PosteriorVar(1)
//%input  Observed(NObserved)
//%input  FixedVar
//%input  KFactor
//%input  PriorMean
//%input  PriorVar

void MFCondLogLik (numtype *ll,const numtype *DataMatr, const numtype *NRepl, const numtype *TSegments,const numtype *TSegmentLength, const numtype *Mu,const numtype *ReplVar,const int DNMaxRepl,const int D,const int NTSegments,const int NMaxSegmentLength);
//%output ll(1)
//%input  DataMatr(DNMaxRepl)
//%input  NRepl(D)
//%input  TSegments(NTSegments, NMaxSegmentLength)
//%input  TSegmentLength( NTSegments)
//%input  Mu(D)
//%input  ReplVar(D)

void MFGetDeviationSigmasq2 (numtype *s,const numtype *offs, const numtype *ssq, const numtype *Mu2,const numtype *BUseStd,const int D, const int T);
//%output s(D)
//%input  offs(D)
//%input  ssq(D)
//%input  Mu2( T)
//%input  BUseStd(1)


void MFUpdatePosteriorMu1 (numtype *PosteriorMean,numtype *PosteriorVar,const numtype *DataMatr, const numtype *NRepl, const numtype *ReplVar,const numtype *KFactor, const numtype *PriorMuMean,const numtype *PriorMuVar,const numtype *TSegments, const int  ModelVersion,const int D, const int DNMaxRepl,const int NTSegments,const int T,const int T1);
//%output PosteriorMean(T1)
//%output PosteriorVar(T1)
//%input  DataMatr(DNMaxRepl) 
//%input  NRepl(D) 
//%input  ReplVar(D)
//%input  KFactor(1)
//%input  PriorMuMean(D)
//%input  PriorMuVar(D)
//%input  TSegments(NTSegments,T)
//%input  ModelVersion

void MFUpdatePosteriorMu2Ver3 (numtype *PosteriorMean,numtype *PosteriorVar,const numtype *DataMatr, const numtype *NRepl, const numtype *ReplVar,const numtype *KFactor,const numtype *PriorMuMean,const numtype *PriorMuVar, const numtype *TSegments,const int ModelVersion, const int D, const int DNMaxRepl,const int NTSegments,const int T,const int T2);
//%output PosteriorMean(T2)
//%output PosteriorVar(T2)
//%input  DataMatr(DNMaxRepl)
//%input  NRepl(D)
//%input  ReplVar(D)
//%input  KFactor(1)
//%input  PriorMuMean(D)
//%input  PriorMuVar(D)
//%input  TSegments(NTSegments, T)

void MFUpdatePosteriorMu3 (numtype *PosteriorMean,numtype *PosteriorVar,const numtype *DataMatr, const numtype *NRepl, const numtype *ReplVar,const numtype *KFactor, const numtype *PriorMuMean,const numtype *PriorMuVar, const numtype *TSegments,const int  ModelVersion,const int D, const int DNMaxRepl,const int NTSegments,const int T,const int T3);
//%output PosteriorMean(T3)
//%output PosteriorVar(T3)
//%input  DataMatr(DNMaxRepl) 
//%input  NRepl(D) 
//%input  ReplVar(D)
//%input  KFactor(1)
//%input  PriorMuMean(D)
//%input  PriorMuVar(D)
//%input  TSegments(NTSegments,T)
//%input  ModelVersion

void MFUpdatePosteriorMu0 (numtype *PosteriorMean,numtype *PosteriorVar,const numtype *Alpha,const numtype *Mu,const numtype *PriorMeanMatr,const numtype *PriorCovDiag,const numtype *PriorMuMean,const numtype *PriorMuVar,const numtype *TSegments,const numtype *CycleDep,const numtype *NCycleDep, const int ModelVersion,const int D, const int DNMaxRepl,const int NTSegments,const int T, const int T2);
//%output PosteriorMean(T2)
//%output PosteriorVar(T2)
//%input  Alpha(1)
//%input  Mu(D)
//%input  PriorMeanMatr(T2)
//%input  PriorCovDiag(T2)
//%input  PriorMuMean(D)
//%input  PriorMuVar(D)
//%input  TSegments(NTSegments, T)
//%input  CycleDep(T2,3)
//%input  NCycleDep(T2)

void MFSampleMu0_MH (numtype *Mu0New,numtype *ProposalMean,numtype *ProposalVar,numtype *PriorMuNewMean, numtype *PriorMuNewVar, const numtype *MG,const numtype *Alpha,const numtype *Inj,const numtype *Mu0Prev, const numtype *Mu,const numtype *ReplVar, const numtype *TSegments,const numtype *CycleDep, const numtype *NCycleDep, const numtype *ProfileMeanMatr,const numtype *ProfileCovDiag,const numtype *PriorMuPrevMean, const numtype *PriorMuPrevVar, const numtype *HC1MG0Mean,const numtype *HC1MG1Mean,const numtype *HC3Inj0Mean,const numtype *HC3Inj1Mean,const numtype *HC1MG0CovDiag,const numtype *HC1MG1CovDiag,const numtype *HC2CovDiag,const numtype *HC3Inj0CovDiag,const numtype *HC3Inj1CovDiag,const numtype *HC1MG0CovOffs,const numtype *HC1MG1CovOffs,const numtype *HC2CovOffs,const numtype *HC3Inj0CovOffs,const numtype *HC3Inj1CovOffs,const numtype *HC1HC2TMapping,const numtype *HC2HC1TMapping,const numtype *HC3HC2TMapping,const numtype *HC2HC3TMapping,const numtype *HC1MGEffectedT,const numtype *HC1MGNotEffectedT,const numtype *HC3InjEffectedT,const numtype *HC3InjNotEffectedT,const numtype *PriorReplVar, const int ModelVersion,const int D, const int DNMaxRepl,const int NTSegments,const int T,const int T1,const int T2,const int T3, const int NMGEffected,const int NMGNotEffected,const int NInjEffected,const int NInjNotEffected);
//%output Mu0New(T2)
//%output ProposalMean(T2)
//%output ProposalVar(T2)
//%output PriorMuNewMean(D)
//%output PriorMuNewVar(D)
//%input  MG(1)
//%input  Alpha(1)
//%input  Inj(1)
//%input  Mu0Prev(T2)
//%input  Mu(D)
//%input  ReplVar(D)
//%input  TSegments(NTSegments, T)
//%input  CycleDep(T2,3)
//%input  NCycleDep(T2)
//%input  ProfileMeanMatr(T2)
//%input  ProfileCovDiag(T2)
//%input  PriorMuPrevMean(D)
//%input  PriorMuPrevVar(D)
//%input  HC1MG0Mean(T1)
//%input  HC1MG1Mean(T1)
//%input  HC3Inj0Mean(T3)
//%input  HC3Inj1Mean(T3)
//%input  HC1MG0CovDiag(T1)
//%input  HC1MG1CovDiag(T1)
//%input  HC2CovDiag(T2)
//%input  HC3Inj0CovDiag(T3)
//%input  HC3Inj1CovDiag(T3)
//%input  HC1MG0CovOffs(T1)
//%input  HC1MG1CovOffs(T1)
//%input  HC2CovOffs(T2)
//%input  HC3Inj0CovOffs(T3)
//%input  HC3Inj1CovOffs(T3)
//%input  HC1HC2TMapping(T1)
//%input  HC2HC1TMapping(T2)
//%input  HC3HC2TMapping(T3)
//%input  HC2HC3TMapping(T2)
//%input  HC1MGEffectedT(NMGEffected)
//%input  HC1MGNotEffectedT(NMGNotEffected)
//%input  HC3InjEffectedT(NInjEffected)
//%input  HC3InjNotEffectedT(NInjNotEffected)
//%input  PriorReplVar(2,NTSegments,T)

void MFSampleInj (numtype *Inj,numtype *pInj, const numtype *PriorInj1,const numtype *Mu,const numtype *PriorMuInj0Mean, const numtype *PriorMuInj0Var, const numtype *PriorMuInj1Mean, const numtype *PriorMuInj1Var, const numtype *TSegments,const int ModelVersion,const int D, const int NTSegments,const int T,const int T3);
//%output Inj(1)
//%output pInj(1)
//%input  PriorInj1(1)
//%input  Mu(D)
//%input  PriorMuInj0Mean(D)
//%input  PriorMuInj0Var(D)
//%input  PriorMuInj1Mean(D)
//%input  PriorMuInj1Var(D)
//%input  TSegments(NTSegments,T)
//%input  ModelVersion

void MFSampleMG (numtype *MG,numtype *pMG, const numtype *PriorMG1,const numtype *Mu,const numtype *PriorMuMG0Mean, const numtype *PriorMuMG0Var, const numtype *PriorMuMG1Mean, const numtype *PriorMuMG1Var, const numtype *TSegments,const int  ModelVersion,const int D, const int NTSegments,const int T,const int T1);
//%output MG(1)
//%output pMG(1)
//%input  PriorMG1(1)
//%input  Mu(D)
//%input  PriorMuMG0Mean(D)
//%input  PriorMuMG0Var(D)
//%input  PriorMuMG1Mean(D)
//%input  PriorMuMG1Var(D)
//%input  TSegments(NTSegments,T)
//%input  ModelVersion

void MFSampleZ(numtype *Z,numtype *PZGivenX, numtype *logPX, numtype *NewMean, numtype *NewCovDiag, numtype *NewGZ, const numtype *DataMatr,const numtype *PClusterCount,const numtype *MeanMatr,const numtype *InvCovDiag,const numtype *LogInvCovDiag,const numtype *GMu0, const numtype *GK0, const numtype *GA1,const numtype *GA2,const numtype *GPZ, const numtype GAlpha, const int FreezeZ, const int K,const int T2, const int GZ);
//%output Z(1)
//%output PZGivenX(K+1)
//%output logPX(1)
//%output NewMean(T2)
//%output NewCovDiag(T2)
//%output NewGZ(1)
//%input  DataMatr(T2)
//%input  PClusterCount(K)
//%input  MeanMatr(K,T2)
//%input  InvCovDiag(K,T2)
//%input  LogInvCovDiag(K,T2)
//%input  GMu0(GZ,T2)
//%input  GK0(GZ,T2)
//%input  GA1(GZ,T2)
//%input  GA2(GZ,T2)
//%input  GPZ(GZ)
//%input  GAlpha

void MFSampleZLabels(numtype *Z,numtype *PZGivenX, numtype *logPX, numtype *NewPostMu, numtype *NewPostK0, numtype *NewPostA1, numtype *NewPostA2, const numtype *DataMatr,const numtype *PClusterCount,const numtype *PostMuComp,const numtype *PostK0Comp,const numtype *PostA1Comp,const numtype *PostA2Comp, const numtype *GMu0, const numtype *GK0, const numtype *GA1,const numtype *GA2,const numtype GAlpha, const int FreezeZ, const int K,const int T2);
//%output Z(1)
//%output PZGivenX(K+1)
//%output logPX(1)
//%output NewPostMu(T2)
//%output NewPostK0(T2)
//%output NewPostA1(T2)
//%output NewPostA2(T2)
//%input  DataMatr(T2)
//%input  PClusterCount(K)
//%input  PostMuComp(K,T2)
//%input  PostK0Comp(K,T2)
//%input  PostA1Comp(K,T2)
//%input  PostA2Comp(K,T2)
//%input  GMu0(GZ,T2)
//%input  GK0(GZ,T2)
//%input  GA1(GZ,T2)
//%input  GA2(GZ,T2)
//%input  GAlpha

void MFUpdatePosteriorAlpha (numtype *PosteriorMean,numtype *PosteriorVar,const numtype *MG,const numtype *Mu0, const numtype *Mu,const numtype *PriorMeanAlpha, const numtype *PriorVarAlpha, const numtype *PriorMuMean, const numtype *PriorMuVar, const numtype *TSegments,const numtype *HC1MGNotEffectedT,const numtype *HC1HC2TMapping,const int ModelVersion, const int D, const int NTSegments,const int T,const int T1,const int T2, const int NMGNotEffectedT);
//%output PosteriorMean(1)
//%output PosteriorVar(1)
//%input  MG(1)
//%input  Mu0(T2)
//%input  Mu(D)
//%input  PriorMeanAlpha(1)
//%input  PriorVarAlpha(1)
//%input  PriorMuMean(D)
//%input  PriorMuVar(D)
//%input  TSegments(NTSegments,T)
//%input  HC1MGNotEffectedT(NMGNotEffectedT)
//%input  HC1HC2TMapping(T1)
//%input  ModelVersion

void MFGetPosteriorMu0_MH (numtype *LogPMu0,const numtype *Mu0Sample,const numtype *ProposalMean,const numtype *ProposalVar,const numtype *Mu0,const numtype *MG,const numtype *Alpha,const numtype *Inj,const numtype *Mu,const numtype *TSegments,const numtype *CycleDep,const numtype *NCycleDep, const numtype *ProfileMeanMatr,const numtype *ProfileCovDiag,const numtype *CombinedPriors, const numtype *HC1HC2TMapping,const numtype *HC2HC1TMapping,const numtype *HC3HC2TMapping,const numtype *HC2HC3TMapping,const numtype *HC1MGEffectedT,const numtype *HC1MGNotEffectedT, const numtype *HC3InjEffectedT,const numtype *HC3InjNotEffectedT, const int ModelVersion,const int NBurnIn,const int NMaxIter,const int D, const int DNMaxRepl,const int NTSegments,const int T,const int T1,const int T2,const int T3, const int NMGEffectedT,const int NMGNotEffectedT,const int NInjEffectedT,const int NInjNotEffectedT);
//%output LogPMu0(1)
//%input Mu0Sample(NMaxIter, T2)
//%input ProposalMean(NMaxIter, T2)
//%input ProposalVar(NMaxIter, T2)
//%input  Mu0(T2)
//%input  MG(1)
//%input  Alpha(1)
//%input  Inj(1)
//%input  Mu(D)
//%input  TSegments(NTSegments, T)
//%input  CycleDep(T2,3)
//%input  NCycleDep(T2)
//%input  ProfileMeanMatr(T2)
//%input  ProfileCovDiag(T2)
//%input  CombinedPriors(17,T)
//%input  HC1HC2TMapping(T1)
//%input  HC2HC1TMapping(T2)
//%input  HC3HC2TMapping(T3)
//%input  HC2HC3TMapping(T2)
//%input  HC1MGEffectedT(NMGEffectedT)
//%input  HC1MGNotEffectedT(NMGNotEffectedT)
//%input  HC3InjEffectedT(NInjEffectedT)
//%input  HC3InjNotEffectedT(NInjNotEffectedT)

#endif
