function [I, gTest, pGTest, W] = mf_periodogram (DataMatr,T)

NT = length(T);

W = 2*pi*[1:floor(NT/2)]/(NT);
I = zeros(size(DataMatr,1), length(W));
for i = 1 : size(DataMatr,1)
    for w = 1 : length(W)
        a = abs(sum(DataMatr(i,:).*exp(-complex(0,1)*W(w)*T)));
        I(i,w) = a*a/NT;
    end
end

gTest = max(I')./sum(I');
[dummy, ordGTest] = sort(-gTest);

%get p-values
pGTest = zeros(size(DataMatr,1),1);
n = length(W);
for i = 1 : size(DataMatr,1)
    p = floor(1/gTest(i));
    for pp = 1 : p
        logTerm = sum(log([1:n])) - sum(log([1:pp])) - sum(log([1:n-pp])) + (n-1)*log(1-pp*gTest(i));
        
        pGTest(i) = pGTest(i) + (-1)^(pp+1)*exp(logTerm);
    end
end

return;

% example of periodic signal with poor periodogram detection
pulse = [1,1,1,1,1,1,1.5,2,1,1];
signal = [pulse,pulse]+mvnrnd(0,0.01,2*length(pulse))'; plot(signal, 'b-x')
[I, gTest, pGTest, W] = mf_periodogram (signal,[1:length(signal)]);; 
plot(I);
figure; title('periodogram');