function [dataMatr, L, R, Len, N, D, Q, X, NRepl, NMaxRepl] = GetDataLRLen(Data)

if isfield(Data, 'v')
    [N, DNMaxRepl, Q] = size(Data.v);
    
    dataMatr = Data.v;
    
    L(1,1:N) = Data.L(1:N);
    R(1,1:N) = Data.R(1:N);
    Len = R - L + 1;

    D = DNMaxRepl;
    NMaxRepl = 1;
else
    [N, D, Q] = size(Data);
    
    dataMatr = Data;

    L(1,1:N) = 1;
    R(1,1:N) = D;
    Len(1:N) = D;
    
    DNMaxRepl = D;
    NMaxRepl = 1;
end

if isfield(Data, 'NRepl')
    NRepl = Data.NRepl;
    if isfield(Data, 'NMaxRepl')
        NMaxRepl = Data.NMaxRepl;
    else
        NMaxRepl = max(max(NRepl));
    end
    
    D = DNMaxRepl / NMaxRepl;
else
    D = DNMaxRepl;
    
    NRepl = zeros(N,D);
    for i = 1 : N
        NRepl(i,1:R(i)) = 1;
    end
end

if isfield (Data, 'x')
    X = Data.x;
else
    X = reshape ([1 : D], D, 1);
end

