function x = GetDataSubset(Data, idxI, idxJ);

if isfield(Data, 'v')
    x.v = Data.v(idxI,:,:);
    x.L = Data.L(idxI);
    x.R = Data.R(idxI);
    
else
    x = Data(idxI,:,:);
end

if isfield (Data, 'x')
    if nargin == 3
        x.x = Data.x(idxJ);
    else
        x.x = Data.x;
    end
end

if isfield (Data, 'NRepl')
    x.NRepl = Data.NRepl(idxI,:);
end

if isfield (Data, 'NMaxRepl')
    x.NMaxRepl = Data.NMaxRepl;
end

if nargin == 3
    if isfield(Data, 'NMaxRepl')
        NMaxRepl = Data.NMaxRepl;
    else
        NMaxRepl = max(max(Data.NRepl));
    end
    
    idxAll = [];
    for j = 1 : length(idxJ)
        idxAll = [idxAll, [1:NMaxRepl] + (idxJ(j)-1)*NMaxRepl];
    end
    
    if isfield(Data, 'v')
        x.v = x.v(:,idxAll,:);
        x.R(:) = length(idxJ);
    else
        x = x(:,idxAll,:);
    end
    
    if isfield (Data, 'NRepl')
        x.NRepl = x.NRepl(:,idxJ);
    end
    
end
