function [M, V, ReplMean, ReplResid, ReplIdx, Median, IQR] = GetReplVar (data, PhaseIdx)

NArgOutTotal =7;

[DataMatr, L, R, Len, N, D, Q, X, NRepl, NMaxRepl] = GetDataLRLen(data);

V = zeros(N, D);
M = zeros(N, D);

ReplMean = zeros(size(data.v));
ReplResid = zeros(size(data.v));

for j = 1 : D
    idx{j} = [1:NRepl(1,j)] + (j-1)*NMaxRepl;
    values = DataMatr(:,idx{j});
    
    M(:,j) = mean(values', 1)';
    if length(idx{j}) == 1
        V(:,j) = 1e-05;
    else
        V(:,j) = var(values')';
    end
    if nargout == NArgOutTotal
        [Median(:,j), IQR(:,j)] = GetIQR(values);
    end
end

if exist('PhaseIdx')
    for q = 1 : length(PhaseIdx)
        ReplIdx{q} = [];
        for j = 1 : length(PhaseIdx{q})
            ReplIdx{q} = union (ReplIdx{q}, [1:NRepl(1,PhaseIdx{q}(j))] + (PhaseIdx{q}(j)-1)*NMaxRepl);
        end
    end
end