function [M, V] = GetReplVar2 (data, VarType)

if sum(sum(isinf(data.v)))  == 0
    [M, V] = GetReplVar(data);
    return;
end

if ~exist('VarType', 'var')
    VarType = 0;
end
[DataMatr, L, R, Len, N, D, Q, X, NRepl, NMaxRepl] = GetDataLRLen(data);

V = zeros(N, D);
M = zeros(N, D);

for i= 1 : N
    for j = 1 : D
        idx{j} = [1:NRepl(1,j)] + (j-1)*NMaxRepl;
        values = DataMatr(i,idx{j});
        values = values(~isinf(values));
        
        if isempty(values)
            M(i,j) = -Inf;
            V(i,j) = -Inf;
        else 
            M(i,j) = mean(values);
            if length(values) == 1
                V(i,j) = -Inf;
            else
                V(i,j) = var(values, VarType);
            end
        end
    end
end

